//*****************************************************************************
//*
//*
//*		CokkieDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"Resource.h"
#include	"AfxUtility.h"
#include	"AfxMacros.h"
#include	"CokkieDlg.h"

#define 	 ID_TREE		0x4561


BEGIN_MESSAGE_MAP(CCookieDlg, CDialog)
	//{{AFX_MSG_MAP(CCookieDlg)
	ON_NOTIFY(TVN_SELCHANGED  ,ID_TREE,OnListSelChanged)
	ON_NOTIFY(TVN_ENDLABELEDIT,ID_TREE,OnListEndEdit)
	ON_BN_CLICKED(IDC_BUTTON1, OnDelete)
	ON_WM_SIZING()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



DLG_SIZING_ITEMS(CCookieDlg,1,1)
	{
	ID_TREE,		0, 0,   1, 1,
	IDOK,			1, 1,   0, 0,
	IDCANCEL,		1, 1,   0, 0,
	};

DLG_OLDSIZE    (CCookieDlg)
DLG_SIZING     (CCookieDlg)
DLG_SIZING_SIZE(CCookieDlg)


HICON CCookieDlg::m_hIcon=0;


//*****************************************************************************
//*
//*		Dialogfeld CCookieDlg
//*
//*****************************************************************************
CCookieDlg::CCookieDlg(CWnd *pParent): CDialog(CCookieDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CCookieDlg)
	//}}AFX_DATA_INIT

	m_uOptions = 0x0238733F;							// Diverse Optionsbits
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CCookieDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CCookieDlg)
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//*
//*		CompareFunc
//*
//*****************************************************************************
int CALLBACK CCookieDlg::CompareFunc(HWND hWnd,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParam)
{
const char	*pText1;
const char	*pText2;
int			 iRet;


	pText1  = ((CTreeListCtrl*)lParam)->GetItemText(hItem1,0);
	pText2  = ((CTreeListCtrl*)lParam)->GetItemText(hItem2,0);

	iRet	= atoi(pText1)-atoi(pText2);

	if(iRet)return iRet;


return strcmp(pText1,pText2);
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  Behandlungsroutinen fr Nachrichten CCookieDlg
BOOL CCookieDlg::OnInitDialog()
{
HTREEITEM		hItem;
TVSORTEX		sSort;
LPCTSTR			pPath;
LPCTSTR			pName;
LPCTSTR			pText;
CRect			sRect;
unsigned		uFlags;
int				iPos;


	// CRegKeys	sKey;
	//sKey.Open(HKEY_CURRENT_USER ,cRegPath);
	//sKey.Up("Settings");
	//sKey.Get(m_uOptions,"Options");

	GetDlgPosRect(this,IDC_FRAME,&sRect);
	m_cTreeList.CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_TABSTOP|WS_VISIBLE|TVS_FULLROWSELECT|TVS_EDITLABELS,sRect,this,ID_TREE);
	m_cTreeList.SetExtendedStyle(TVS_EX_ITEMLINES|TVS_EX_SUBSELECT|TVS_EX_ALTERNATECOLOR|TVS_EX_FULLROWMARK|TVS_EX_EDITCLICK);
	m_cTreeList.InsertColumn(0,"URL"  ,TVCFMT_LEFT,180);
	m_cTreeList.InsertColumn(1,"Name" ,TVCFMT_LEFT,120);
	m_cTreeList.InsertColumn(2,"Text" ,TVCFMT_LEFT,-1);


						     uFlags =TVS_EX_HOMEENDSELECT;
	if(m_uOptions&0x00000010)uFlags|=TVS_EX_ALTERNATECOLOR;
	if(m_uOptions&0x00000020)uFlags|=TVS_EX_ITEMLINES;

	m_cTreeList.SetExtendedStyle(uFlags,TVS_EX_HOMEENDSELECT|TVS_EX_ITEMLINES|TVS_EX_ALTERNATECOLOR);

	m_cTreeList.SetColumnAutoEdit(0,TVAE_DBLCLICK|TVAE_FULLWIDTH|TVAE_EDIT);
	m_cTreeList.SetColumnAutoEdit(1,TVAE_DBLCLICK|TVAE_FULLWIDTH|TVAE_EDIT);
	m_cTreeList.SetColumnAutoEdit(2,TVAE_DBLCLICK|TVAE_FULLWIDTH|TVAE_EDIT);


	DLG_SIZING_INIT()
	SET_DLG_OLDSIZE()


	for(iPos=2;iPos<m_sCookies.Count();iPos+=3)		// Cookies einfgen
		{
		pPath  = m_sCookies[iPos-2];
		pName  = m_sCookies[iPos-1];
		pText  = m_sCookies[iPos  ];
		hItem  = m_cTreeList.InsertItem(pPath);
				 m_cTreeList.SetItemText(hItem,pName,1);
		         m_cTreeList.SetItemText(hItem,pText,2);
		}


	sSort.hParent		= TVI_ROOT;
    sSort.lpfnCompare	= CompareFunc;
    sSort.lParam		= (LPARAM)&m_cTreeList;


	m_cTreeList.SortChildrenEX(&sSort);
	hItem  = m_cTreeList.InsertItem("");

	if(!m_hIcon)
		{
		m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
		}

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	CDialog::OnInitDialog();


return TRUE;
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CCookieDlg::OnOK()
{
CString		sText;
TVSORTEX	sSort;
HTREEITEM	hItem;	
LPCTSTR		pPath;
LPCTSTR		pName;
LPCTSTR		pText;
int			iPos;



	GET_DLG_OLDSIZE()

	sSort.hParent		= TVI_ROOT;
    sSort.lpfnCompare	= CompareFunc;
    sSort.lParam		= (LPARAM)&m_cTreeList;


	m_cTreeList.SortChildrenEX(&sSort);

	iPos  = 0;
	hItem = m_cTreeList.GetChildItem(TVI_ROOT);
	
	while(hItem)
		{
		    pText = m_cTreeList.GetItemText(hItem,2);
			pName = m_cTreeList.GetItemText(hItem,1);
		    pPath = m_cTreeList.GetItemText(hItem,0);
		if(*pPath)
			{
			if(strcmp(pPath,m_sCookies[iPos  ]))break;
			if(strcmp(pName,m_sCookies[iPos+1]))break;
			if(strcmp(pText,m_sCookies[iPos+2]))break;
			iPos += 3;
			}

		hItem = m_cTreeList.GetNextSiblingItem(hItem);
		}

	if(!hItem)										// Keine nderungen
		{
		OnCancel();
		}
	
	iPos  = 0;
	hItem = m_cTreeList.GetChildItem(TVI_ROOT);

	m_sCookies.Del();
	
	while(hItem)
		{
		    pText = m_cTreeList.GetItemText(hItem,2);
			pName = m_cTreeList.GetItemText(hItem,1);
		    pPath = m_cTreeList.GetItemText(hItem,0);
		if(*pPath)
			{
			m_sCookies.Add(pPath,iPos);iPos++;
			m_sCookies.Add(pName,iPos);iPos++;
			m_sCookies.Add(pText,iPos);iPos++;
			}

		hItem = m_cTreeList.GetNextSiblingItem(hItem);
		}


	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CCookieDlg::OnCancel()
{

	GET_DLG_OLDSIZE()
	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnDelete
//*
//*****************************************************************************
void CCookieDlg::OnDelete()
{
HTREEITEM	hItem;
HTREEITEM	hNext;


		hItem = m_cTreeList.GetFocusItem();
	if(!hItem)return;

		hNext = m_cTreeList.GetNextSiblingItem(hItem);
	if(!hNext)
		{
		return;
		}

	m_cTreeList.DeleteItem(hItem);
	m_cTreeList.SetFocusItem(hNext);

	hNext = m_cTreeList.GetNextSiblingItem(hNext);
	GetDlgItem(IDC_BUTTON1)->EnableWindow((hNext)? TRUE:FALSE);


}

//*****************************************************************************
//*
//*		OnListSelChanged
//*
//*****************************************************************************
void CCookieDlg::OnListSelChanged(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTREEVIEW *pChange=(NMTREEVIEW*)pNmHdr;
int			iRow;
int			iMax;


   *pResult	= 0;
	iRow	= m_cTreeList.GetRowOfItem(pChange->itemNew.hItem);
	iMax	= m_cTreeList.GetCount()-1;

	GetDlgItem(IDC_BUTTON1)->EnableWindow(iRow+1>=iMax);

}


//*****************************************************************************
//*
//*		OnListEndEdit
//*
//*****************************************************************************
void CCookieDlg::OnListEndEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTVDISPINFO   *pItem = (NMTVDISPINFO*)pNmHdr;
HTREEITEM		hItem;
HTREEITEM		hNext;
int				iSub;
int				iAdd;



	if(!(pItem->item.mask&TVIF_TEXTCHANGED))			// Hat sich der Text verndert
		{
		if(m_uOptions&0x00008000)						// In eine neue Zeile springen
		if(pItem->item.mask&TVIF_RETURNEXIT)
			{
			   hNext = m_cTreeList.GetNextItem(pItem->item.hItem);
			if(hNext)
				{
				m_cTreeList.SelectItem(hNext,pItem->item.cChildren);
				}
			
			*pResult = 0;
			}
		else{
			*pResult = 1;
			}

		return;
		}
														// Wurde ein Text bergeben
	if(pItem->item.pszText==0 || !(pItem->item.mask&TVIF_TEXT))
		{
		*pResult = 1;
		return;
		}

	hItem	= pItem->item.hItem;
	iSub	= pItem->item.cChildren;
	iAdd	= 0;

	if(pItem->item.pszText[0]==0)
		{
			hNext=m_cTreeList.GetNextItem(hItem);
		if(!hNext)return;

		if(iSub==0)
			{
			m_cTreeList.DeleteItem(hItem);
			m_cTreeList.SelectItem(hNext);
			}
		}
	else{
		if(!m_cTreeList.GetNextItem(hItem))
			{
			m_cTreeList.InsertItem("");
			iAdd = 1;
			}
		}

	if(m_uOptions&0x00008000)							// In eine neue Zeile springen
	if(pItem->item.mask&TVIF_RETURNEXIT)
		{
		if(iAdd && iSub==0)
			{
			m_cTreeList.SelectItem(hItem,1);
			}
		else{
			   hNext = m_cTreeList.GetNextItem(hItem);
			if(hNext)
				{
				if(iSub==2 && !m_cTreeList.GetNextItem(hNext))
					{
					iSub=1;
					}

				m_cTreeList.SelectItem(hNext,iSub);
				}
			}
		}

	*pResult = 0;

}

