//*****************************************************************************
//*
//*
//*		CHttpScan
//*
//*
//*****************************************************************************
#include	"StdAfx.h"

#define 	AZ_LIB_ADDAFX
#include	<afxinet.h>
#include	<stdio.h>
#include	"FileBuffer.h"
#include	"FileFunctions.h"
#include	"HttpScan.h"


#define 	MAX_WEBPATH	512
#define 	WEB_TYPES	"htm;html;php;php3;asp;aspx;cgi"


DWORD		dwHttpRequestFlags	= INTERNET_FLAG_EXISTING_CONNECT | INTERNET_FLAG_NO_AUTO_REDIRECT;
const TCHAR cHeaders[]			= _T("Accept: text/html.application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\nUser-Agent: AZ_HttpScan\r\n");

char		*IndexNames[] = 
				{	
				"index.html",
				"welcome.html",
				"index.htm",
				"welcome.htm",
				"Index.html",
				"Welcome.html",
				"Index.htm",
				"Welcome.htm",
				"INDEX.HTM",
				"WELCOME.HTM",
				"",
				0};



//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CHttpScan::CHttpScan()
{
	path_name[0] = 0;
	last_path = GetTickCount();
	dwFileLength=0;
	dwAccessType=INTERNET_OPEN_TYPE_DIRECT;
	dont_scan.DataLength(sizeof(int));
	sfilter_mode=0;
	sfilter_on=0;
	scantype=0;
	wiki=0;
	proc=0;
	stop=0;
	tick=0;

	wfilter.Add("&action=");
	wfilter.Add("&amp;action=");
	wfilter.Add("&search=");
	wfilter.Add("&amp;search=");
	wfilter.Add("&printable=");
	wfilter.Add("&amp;printable=");
	wfilter.Add("&oldid=");
	wfilter.Add("&amp;oldid=");
	wfilter.Add("=Special:");
	wfilter.Add("=Special%3A");
	wfilter.Add("=File:");

	cookies.Add("http://mediawiki.automationx.com");
	cookies.Add("aXwiki_aX_UserID");  
	cookies.Add("38");

	cookies.Add("http://mediawiki.automationx.com");
	cookies.Add("aXwiki_aX_UserName");
	cookies.Add("Azechner");

	cookies.Add("http://mediawiki.automationx.com");
	cookies.Add("aXwiki_aX_Token");
	cookies.Add("a0e18ed43964ea31ddceca2ae4d61dc9");

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CHttpScan::~CHttpScan()
{

}


//*****************************************************************************
//*
//*		GetPath
//*
//*****************************************************************************
//	Entfernt #? aus einem Pfad
LPCSTR CHttpScan::GetPath(LPCSTR Path)
{


	xpath=Path;
	xpath.Remove('*');
	xpath.Remove('?');


return xpath;
}

//*****************************************************************************
//*
//*		SetMinusFilter
//*
//*****************************************************************************
int CHttpScan::SetMinusFilter(LPCTSTR Filter)
{
int		len,anz=0;
char    filter[256]="*.";


	mfilter.Del();
	if(!Filter)return 0;

	while(*Filter)
		{
		len=strchar(Filter,';');
		if(len && len<250)
			{
			strncpy(filter,Filter,len);
			filter[len]=0;
			mfilter.Add(len,Filter);

			filter[len+1]=0;
			if(len>4 && !stricmp(filter+len-4,".htm"))
				{
				filter[len]='l';
				mfilter.Add(filter);
				filter[len]=0;
				}
			if(len>5 && !stricmp(filter+len-5,".html"))
				{
				filter[len-1]=0;
				mfilter.Add(filter);
				}

			anz++;
			}

			Filter+=len;
		if(*Filter)Filter++;
		}


return anz;
}

//*****************************************************************************
//*
//*		SetPlusFilter
//*
//*****************************************************************************
int CHttpScan::SetPlusFilter(LPCTSTR Filter)
{
int		len,nr,anz=0;
char   *types,*ptr,filter[256]="*.";



	pfilter.Del();
	if(!Filter || !*Filter)return 0;

	while(*Filter)
		{
		len=strchar(Filter,';');
		if(len && len<250)
			{
			strncpy(filter,Filter,len);
			filter[len]=0;
			pfilter.Add(len,Filter);

			filter[len+1]=0;
			if(len>4 && !stricmp(filter+len-4,".htm"))
				{
				filter[len]='l';
				pfilter.Add(filter);
				filter[len]=0;
				}
			if(len>5 && !stricmp(filter+len-5,".html"))
				{
				filter[len-1]=0;
				pfilter.Add(filter);
				}

			anz++;
			}

			Filter+=len;
		if(*Filter)Filter++;
		}


	types=WEB_TYPES;
	while(*types)
		{
		len=strcspn(types,";");
		memcpy(filter+2,types,len);
		filter[len+2]=0;

			types+=len;
		if(*types)types++;

		for(nr=0;nr<pfilter.Count();nr++)
			{
			ptr=strstr(pfilter[nr],filter+2);
			if(!ptr)continue;
			if(ptr[len]==0)break;
			}
		if(nr>=pfilter.Count())pfilter.Add(filter);
		}

return anz;
}


//*****************************************************************************
//*
//*		SetSubFilter
//*
//*****************************************************************************
//	Setzt einen Pfad mit in dem alle HTML Dateien nche der ersten liegen mssen
//	Wenn Filter==0 oder Filter=="" wird der Filder gelscht
int CHttpScan::SetSubFilter(LPCTSTR Filter)
{

	if(!Filter || *Filter==0)
		{
		sfilter_mode=0;
		sfilter_on=0;
		sfilter="";
		return 0;
		}

	sfilter = Filter;

	if(strstr(Filter,"*") || strstr(Filter,"?"))
		{
		sfilter_mode = 1;
		sfilter_on   = 1;
		return 1;
		}

	AddBackSlash(sfilter);
	CheckWebPath(sfilter);
	sfilter_mode = 0;
	sfilter_on   = 1;


return 1;
}


//*****************************************************************************
//*
//*		CheckWebPath
//*
//*****************************************************************************
//	Ergibt 1 wenn Path ein Internet Pfad ist
//	Pfade die nicht mit "http:" anfangen werden erweitert
int CHttpScan::CheckWebPath(CString &Path)
{
int		x;

	   x=IsWebPath(Path);
	if(x==2)
		{
		CString temp;
		temp=Path;
		Path ="http://";
		Path+=temp;
		x=1;
		}

	PathConvert(Path,'/');


return x;
}

//*****************************************************************************
//*
//*		IsWebPath
//*
//*****************************************************************************
//	Ergibt 1 wenn Path ein Internet Pfad ist                   "http://xxxx"
//	Ergibt 2 wenn Path ein unvollstntiger Internet Pfad ist   "www.xxxxxxx"
int CHttpScan::IsWebPath(const char *Path)
{
	if(!strnicmp(Path,"www."    ,4))return 2;
	if(!strnicmp(Path,"http://" ,7))return 1;
	if(!strnicmp(Path,"https://",8))return 1;

return 0;
}



//*****************************************************************************
//*
//*		IsFile
//*
//*****************************************************************************
//	Ergibt 1 wenn Path auf eine Datei zeigt "xxxxxxxxxxxxx\yyy.zzz"
//	Ergibt 0 wenn Path ohne Dateinamen ist  "xxxxxxxxxxxxx\"
int CHttpScan::IsFile(const char *Path)
{
int len,is_web;



	   is_web=IsWebPath(Path);
	if(is_web)
		{
		len=FilePathLen(Path,3-is_web);
		if(!len      )return 0;
		if(!Path[len])return 0;
			len=strlen(Path);
		if(!len      )return 0;
		if(Path[len-1]=='/' )return 0;
		if(Path[len-1]=='\\')return 0;
		}
	else{
			len=strlen(Path);
		if(!len)return 0;
		if(Path[len-1]=='/'  )return 0;
		if(Path[len-1]=='\\' )return 0;
		if(ExistFile(Path)>=2)return 0;
		}

return 1;
}


//*****************************************************************************
//*
//*		SetLogProc
//*
//*****************************************************************************
int	CHttpScan::SetLogProc(void (__cdecl *Proc)(void *,const char *,int),void *Param)
{

	proc  = Proc;
	param = Param;

return 1;
}

//*****************************************************************************
//*
//*		GetFile
//*
//*****************************************************************************
//	Liest eine Datei von einem Web-Server ein.
//	HttpPath	: HTTP oder HTTPS Pfad
//	FilePath	: Ist der Pfad wo die Datei gespeichert werden soll.
//	Test		: Sollen Fehlermeldungen ausgegeben werden
//	ForceHtml	: Hier wird gespeichert ob eine nicht HTML-Datei eine
//				  HTML-Datei war. Dazu muss das Flag scantype gesetzt sein
//	Ergibt 0 wenn ok, oder eine Fehlernummer.
int CHttpScan::GetFile(LPCTSTR HttpPath,LPCTSTR FilePath,int Test,int *ForceHtml)
{
CString	 path;
FILE	*file;
TCHAR	 cBuffer[1024];
char	 block[512];
int		 nRetCode=0;
int		 type_html=0;
int		 nPlace;
int		 blen=0;
int		 flen=0;
int		 count;
int		 pos;




	if(ForceHtml)*ForceHtml=0;

	dwFileLength=0;

	if(stop)return -2;								// Benutzer Abbruch


	GetFilePath (path,FilePath);
	DelBackSlash(path);

	if(ExistFile(GetPath(path))==1)					// Datei lschen falls sie wie der Pfad heit
		{
		DeleteFile(GetPath(path));
		}

	CreatePath(GetPath(path));
	strlcpy(path_name,HttpPath,sizeof(path_name));
	last_path = GetTickCount();

		file=fopen(GetPath(FilePath),"wb");
	if(!file)return -1;


	CInternetSession session(_T("AZ - Http Grapper"),1,dwAccessType);
	CHttpConnection *pServer = NULL;
	CHttpFile		*pFile   = NULL;
	
	try	{
		CString strObject;
		CString strServerName;
		CString strNewLocation;
		DWORD	dwServiceType;
		DWORD	dwPrompt;
		DWORD	dwFlags;
		DWORD	dwRet;
		WORD	nPort;
								   

		if(!AfxParseURL(HttpPath,dwServiceType,strServerName,strObject,nPort))
			{
			throw 1;
			}

		if(dwServiceType!=INTERNET_SERVICE_HTTP && dwServiceType!=AFX_INET_SERVICE_HTTPS)
			{
			throw 1;
			}

		tick++;
											
		pServer = session.GetHttpConnection(strServerName,nPort);

		for(pos=2;pos<cookies.Count();pos++)		// Cookiers einstellen
			{
			session.SetCookie(cookies[pos-2],cookies[pos-1],cookies[pos]);
			}

		dwFlags = (dwServiceType==AFX_INET_SERVICE_HTTPS)? INTERNET_FLAG_SECURE:0;
		pFile   = pServer->OpenRequest(CHttpConnection::HTTP_VERB_GET,strObject,NULL,1,NULL,NULL,dwHttpRequestFlags|dwFlags);

		pFile->AddRequestHeaders(cHeaders);
		pFile->SendRequest();
		pFile->QueryInfoStatusCode(dwRet);

		

		if(dwRet==HTTP_STATUS_DENIED)					// if access was denied, prompt the user for the password
			{
			   dwPrompt = pFile->ErrorDlg(NULL,ERROR_INTERNET_INCORRECT_PASSWORD,FLAGS_ERROR_UI_FLAGS_GENERATE_DATA|FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS,NULL);
			if(dwPrompt!=ERROR_INTERNET_FORCE_RETRY)	// if the user cancelled the dialog, bail out
				{
				throw 1;
				}

			pFile->SendRequest();
			pFile->QueryInfoStatusCode(dwRet);
			}

		
		pFile->QueryInfo(HTTP_QUERY_RAW_HEADERS_CRLF,strNewLocation);

														// were we redirected?  these response status codes come from WININET.H
		if(dwRet==HTTP_STATUS_MOVED || dwRet==HTTP_STATUS_REDIRECT || dwRet==HTTP_STATUS_REDIRECT_METHOD)
			{
			pFile->QueryInfo(HTTP_QUERY_RAW_HEADERS_CRLF, strNewLocation);

			   nPlace = strNewLocation.Find(_T("Location: "));
			if(nPlace==-1)
				{
				throw 2;
				}

			strNewLocation = strNewLocation.Mid(nPlace + 10);
			nPlace         = strNewLocation.Find('\n');
			
			if(nPlace>0)
				{
				strNewLocation = strNewLocation.Left(nPlace);
				}

			pFile->Close();
			delete pFile;
			pServer->Close();
			delete pServer;


													// figure out what the old place was
			if(!AfxParseURL(strNewLocation,dwServiceType,strServerName,strObject,nPort))
				{
				throw 2;
				}

			if(dwServiceType!=INTERNET_SERVICE_HTTP && dwServiceType!=AFX_INET_SERVICE_HTTPS)
				{
				throw 2;
				}

			pServer = session.GetHttpConnection(strServerName,nPort);
			dwFlags = (dwServiceType==AFX_INET_SERVICE_HTTPS)? INTERNET_FLAG_SECURE:0;
			pFile   = pServer->OpenRequest(CHttpConnection::HTTP_VERB_GET,strObject,NULL,1,NULL,NULL,dwHttpRequestFlags|dwFlags);

			pFile->AddRequestHeaders(cHeaders);
			pFile->SendRequest();
			pFile->QueryInfoStatusCode(dwRet);
			
			if(dwRet!=HTTP_STATUS_OK)
				{
				throw 2;
				}
			}


		for(;;)
			{
			if(stop)throw -2;
			
				count=pFile->Read(cBuffer, sizeof(cBuffer));
			if(!count)break;

												// Prfe ob HTML Typ Fehler
			if(!flen && count>16 && !CmpFileType(FilePath,WEB_TYPES))
				{
				pos = strwlen(cBuffer,0xF0,count-16);
				
				if(!strnicmp(cBuffer+pos,"<HTML>",6) || !strnicmp(cBuffer+pos,"<!DOCTYPE",8))
					{
					if(!scantype)throw -3;
					if(ForceHtml)*ForceHtml=1;
					}
				}

			if(blen<sizeof(block))
				{
				int i;

				i=sizeof(block)-blen;
				if(count<i)i=count;
				memcpy(block+blen,cBuffer,i);
				blen+=i;
				}

			flen+=count;
			fwrite(cBuffer,count,1,file);
			dwFileLength=flen;
			tick++;
			}


		pFile  ->Close();
		pServer->Close();
		}
	catch (CInternetException *pEx)					// catch errors from WinINet
		{
		pEx->GetErrorMessage(cBuffer,1024);

		if(!Test)
			{
			error_text = cBuffer;
			error_file = HttpPath;
			}

		nRetCode = pEx->m_dwError;
		pEx->Delete();
		}
	catch (int pEx)									// catch things wrong with parameters, etc
		{
		nRetCode = pEx;

		if(!Test)
			{
			if(nRetCode==-3)
					error_text.Format("Error: Reciving wrong FileType");
			else	error_text.Format("Error: Exiting with CTheadException(%d)",nRetCode);
			
			error_file = HttpPath;
			flen = 1;
			}
		}

	if(flen<=0)
		{
		nRetCode=-1;
		
		if(!Test)
			{
			error_text.Format("Error: Reviving empty file.");
			error_file=HttpPath;
			}
		}

	if(pFile  !=NULL)delete pFile;
	if(pServer!=NULL)delete pServer;

	session.Close();

	fclose(file);

	if(nRetCode)
		{
		RemoveFile(GetPath(FilePath));
		}
	else{
		if(blen>=sizeof(block))blen=sizeof(block)-1;
		block[blen]=0;

		if(flen<0x20000 && strifind(block,"<HTML>")>=0)
			{
			char buffer[0x20000];

				file=fopen(GetPath(FilePath),"rb");
			if(!file)return nRetCode;
			fread(buffer,flen,1,file);
			fclose(file);

				file=fopen(GetPath(FilePath),"wb");
			if(!file)return nRetCode;
			fprintf(file,"<!-- saved from url=(0039)%s -->\n",HttpPath);
			fwrite(buffer,flen,1,file);
			fclose(file);
			}
		}


return nRetCode;
}



//*****************************************************************************
//*
//*		WritePath
//*
//*****************************************************************************
//	Schreibt den Pfad 'Path' nach File
//	Der Pfad wird dabei in einen realtiven Pfad umgewandelt
//	BasePath	: Web-Basis-Pfad der Datei in der 'Path' stand
//	Path		: Pfad der gespeichert werden soll
//	FileBase	: Disk-Pfad der Datei in der 'Path' stand
//	File		: Dort wird der Basis Pfad gespeichert
//	Suffix		: Wenn 1 dann werden Anfrungszeichen mit gespeichert
//	Ergibt 1 wenn ein realtiver Pfad erzeugt werden konnte sonst 0
int	CHttpScan::WritePath(const char  *BasePath,
						 const char  *Path,
						 const char  *FileBase,
						 CFileBuffer *File,
						 int		  Suffix)
{
CString		path,temp,base,name,add;
int			len,nr,is_web,done;
char	   *file;


	if(wiki)									// "index.php?xxxx" in "index.xxxx.htm" umwandeln		
		{
		name = Path;
		ConvertPathEx(name);
		Path = name;
		}


	path    = Path;
	is_web  = CheckWebPath(path);
	len=strcspn(Path,"#&");
	if(Path[len])
		{
		path=path.Left(len);
		add =Path+len;
		}



	if(is_web)									// "http://xyz" zu "http://xyz/"
		{
		len	=  FilePathLen(path,2);
		if(CmpFileType((LPCSTR)path+len,""))
			{
			   len  = strlen(path);
			if(len && path[len-1]!='/')path+="/";
			}
		}

	   is_web |= IsWebPath(BasePath);
	if(is_web)									// Zu absoluten Web-Pfad machen
		{
		PathFullMake(temp,BasePath,path,2);
		len	= FilePathLen(path,2);
		if(CmpFileType((LPCSTR)path+len,""))	// "http://xyz" zu "http://xyz/"
			{
			   len  = strlen(path);
			if(len && path[len-1]!='/')path+="/";
			}
		}
	else{   
		AddFileName (temp,BasePath,path);
		}

	len=PathOffset (path,BasePath,temp,2);		// Erzeuge relativ Pfad
	    PathConvert(path,'/');

	if(len<0)									// Relativ Pfad nicht mglich
		{
		path=Path;
		add="";
		}
	else{
		if(!len || path[len-1]=='/')			// Suche HTLM Startseite
			{
			GetFilePath(temp,FileBase);
			temp+=path;
			for(nr=0;IndexNames[nr];nr++)
				{
				SetFileName(temp,IndexNames[nr]);
				if(ExistFile(GetPath(temp)))break;
				}
			if(!IndexNames[nr])nr=0;
			path+=IndexNames[nr];
			}
		}


	if(CmpFileType(path,"htm;php"))				// "*.htm" zu "*.html"
		{
		SetFileType(path,"html");
		}

	file=GetFileName(path);
	for(nr=1;IndexNames[nr];nr++)				// Tausche "welcome.html" to "index.html"
		{
		if(stricmp (file,IndexNames[nr]))continue;
		SetFileName(path,IndexNames[0]);
		break;
		}

			
	if(scantype && !CmpFileType(path,WEB_TYPES))// Ist eine Datei fr einen anderen Typ
		{
		done = 0;
		base = FileBase;
		SubFileName(base);
		AddFileName(base,path);


		if(CmpFileType(path,""))
			{
			temp  = base ;
			temp += "/index.html";

			if(ExistFile(base)==2 && ExistFile(temp)==1)
				{
				path += "/index.html";
				done  = 1;
				}
			}

		if(done==0)
			{		
			temp  = base ;
			temp += ".link.html";

			if(ExistFile(base)==0 && ExistFile(temp)==1)
				{
				path += ".link.html";
				}
			}
		}

	PathConvert(path,'/');
	if(Suffix)File->Write("\"" ,1);
			  File->Write(path);
			  File->Write(add);
	if(Suffix)File->Write("\" ",2);



return len>=0;
}


//*****************************************************************************
//*
//*		SetAccessType
//*
//*****************************************************************************
void CHttpScan::SetAccessType(int iType)
{
int aType[3]={	INTERNET_OPEN_TYPE_PRECONFIG,
				INTERNET_OPEN_TYPE_DIRECT,
				INTERNET_OPEN_TYPE_PROXY
		  	};

	if(iType>=0 && iType<=2)dwAccessType=aType[iType];

}

//*****************************************************************************
//*
//*		IsInWikiFilter
//*
//*****************************************************************************
//	Prft ob ein Link von einem WIKI-Filter gesperrt wird
int CHttpScan::IsInWikiFilter(const char *Link,int Len)
{
const char *ptr;
int			off;
int			len;
int			pos;

	
	if(!wiki)return 0;
	if(Len<0)Len=strlen(Link);

	len = strlen(Link);

	while(len>0)										// Suche Dateinamen	
		{
		if(Link[len-1]=='/')break;
		if(Link[len-1]==':' && len>1 && Link[len-2]=='/')break;
		len--;
		} 

	Link += len;
	off   = strchar(Link,'?');

	if(!Link[off])
		{
		off = strchar(Link,'0');
		if(!Link[off])return 0;
		return -1;
		}

	Link += off;

	for(pos=0;pos<wfilter.Count();pos++)				// Prfe die Filter
		{
		ptr = wfilter[pos];
		if(strlfind(Link,ptr,Len)>=0)return pos+1;
		}	


return 0;
}

//*****************************************************************************
//*
//*		InsertLink
//*
//*****************************************************************************
//	Fgt einen Link in die Scan-Liste ein
//	Link	: Zeiger auf den Link 		
//	Orig	: Zeiger auf den originalen Link ("" wenn  nicht vorhanden)		
//	Kette	: Hier wird der Link eingefgt
//	Ergibt einen Zeiger auf den benutzen Link
LPCTSTR	CHttpScan::InsertLink(const char *Link,char *Orig,CStringChain *Kette)
{
LPCTSTR		used;
int			off;
int			num;
int			len;

	
	if(!Orig)										// Kein originaler Pfadpuffer
		{
		len  = strlen(Link);
		used = Link;
		}
	else if(Orig[0])								// Wurd der originale Link gefunden
		{
		used = Orig;
		len  = strlen(Orig);
		}
	else{												
		len  = strlcpy(Orig,Link,MAX_WEBPATH);
		used = Link;
		}

	off = len;

	while(off>0)									// Suche Dateinamen	
		{
		if(used[off-1]=='/')break;
		if(used[off-1]==':' && off>1 && used[off-2]=='/')break;
		off--;
		} 

	if(wiki)
		{
		num = strcspn(used+off,"#?&");
		
		if(used[off+num]=='#')						// Anker entfernen
			{
			len = off+num;
			}
		else{
			   num = strcspnr(used+off,"#?&\\/",len-off);
			if(num>0 && used[off+num]=='#')
				{
				len = off+num;
				}
			}
		}
	else{
		num = strcspn(used+off,"#?&");

		if(used[off+num])							// Anker und Zustze entfernen
			{
			len = off+num;
			}
		}

	if(len>0)										// Linkpfad in Pfadliste speichern
		{
		if(!IsInWikiFilter(used,len))
			{
			Kette->Add(len,used);
			}
		}


return used;
}

//*****************************************************************************
//*
//*		ExistLink
//*
//*****************************************************************************
//	Prft ob die Link-Datei zu einem Dateipfad existiert.
int	CHttpScan::ExistLink(const char *Path,CString *Temp)
{
CString		temp;


	if(scantype==0)
		{
		return 0;
		}

	if(CmpFileType(Path,WEB_TYPES))
		{
		return 0;
		} 
	
	if(!Temp)Temp=&temp;

	*Temp  = Path;
	*Temp += ".link.html";

	if(LengthFile(*Temp)> 0)
		{
		return 1;
		}


return 0;
}


//*****************************************************************************
//*
//*		ScanFile
//*
//*****************************************************************************
//	FilePath	: Datei die gescannt werden soll
//	Kette		: Dort werden alle gefunden Pfadangaben gespeichert
//	OutPath		: Datei fr die Ausgaben(NULL=Keine Ausgabe)
//	BasePath	: Web-Basis-Pfad der Datei ("http://www.abcdef.com/xyz/")
//	Ergibt die Anzahl der gefundenen Pfadangaben
int	CHttpScan::ScanFile(LPCTSTR FilePath,CStringChain *Kette,LPCTSTR OutPath,LPCTSTR BasePath)
{
const char		*link;
char			*mem,zeichen;
char			 wort[MAX_WEBPATH];
char			 orig[MAX_WEBPATH];	
int				 add=0,len,end;
CTextBuffer		 in,out;




	if(!in.Open(GetPath(FilePath)))return 0;

	if(OutPath)
		{
		if(!out.Open(GetPath(OutPath),CRK_CREATE))return 0;
		}

	if(!BasePath)BasePath="";

	while(in.Text(add,&mem))
		{
		if(stop)return -1;					// Benutzer Abbruch

		for(add=0;mem[add];add++)			// Suche TAG
			{
			if(mem[add]=='<')break;
			}

		out.Write(mem,add);
		if(mem[add]!='<')continue;

		   out.Write(mem+add,1);
			in.Text(add+1,&mem);
		add=in.TextWord(wort,sizeof(wort));
		   out.Write(mem,add);
			in.Text(add,&mem);
		add=0;
											// Referenz
		if(!stricmp(wort,"A") || !stricmp(wort,"LINK"))
			{
			orig[0] = 0;

			for(;;)							// Vor auf HREF
				{
				    in.Text(add,&mem);
				add=in.TextEmpty(1);
				   out.Write(mem,add);
					in.Text(add,&mem);

				if(mem[0]=='>')				// Ende von <a ... >
					{
					out.Write(mem,1);
					in.Text(1,&mem);
					wort[0]=0;
					add=0;
					break;
					}
											// Ende von <a ... />
				if(mem[0]=='/' && mem[1]=='>')
					{
					out.Write(mem,2);
					in.Text(2,&mem);
					wort[0]=0;
					add=0;
					break;
					}

				add = in.TextWord(wort,sizeof(wort));

				if(!stricmp(wort,"ORIG"))	// Den originalen LINK kopieren und nicht speichern
					{
						in.Text(add,&mem);
					add=in.TextEmpty(1);

						in.Text(add,&mem);
					add=in.TextChar(&wort[0]);

						in.Text(add,&mem);
					add=in.TextEmpty(1);

					if(wort[0]!='=')
						{
						wort[0]=0;
						break;
						}

						in.Text(add,&mem);
					add=in.TextWordEx(orig,sizeof(orig));
					continue;
					}

				//**** HREF ***************************************************

				if(!stricmp(wort,"HREF"))
					{
						in.Text(add,&mem);
					add=in.TextEmpty(1);
						in.Text(add,&mem);
					if(*mem!='=')
						{
						out.Write(wort);
						if(add)out.Write("    ",(add>=4)? 4:add);
						add=0;
						continue;
						}

					in.Text(1,&mem);
					in.Text(add,&mem);

					if(mem[0]=='\'')
						{
						add=in.TextString(wort,sizeof(wort),'\'','\'');
						}
					else{
						add=in.TextString(wort,sizeof(wort));
						}

					out.Write(" orig=\"");		// originalen Linkpfad anhngen
					out.Write((orig[0])? orig:wort);
					out.Write("\" href=");

					if(add<=0)
						{
						out.Write("\"\" ");
						continue;
						}

					link = InsertLink(wort,orig,Kette);
					WritePath(BasePath,link,FilePath,&out);

					continue;
					}

				//**** STYLE **************************************************

				if(!stricmp(wort,"STYLE"))
					{
					   len = memycmp("=\"background-image:\\.url(",mem+add,256,0x04);
					if(len>0)
						{
						add += len;
						out.Write(mem,add);
							in.Text(add,&mem);
						end = strchar(mem,'>' ,256);
						end = strlchar(mem,'"',end);
						len = strchar(mem,')' ,end);

						strlcpy(wort,mem,sizeof(wort),len);
						InsertLink(wort,0,Kette);
						WritePath(BasePath,wort,FilePath,&out,0);

						out.Write(mem+len,end-len);
						in.Text(end,&mem);
						add = 0;
						continue;
						}
					}

				//*************************************************************

				out.Write(mem,add);
					in.Text(add,&mem);
				add=in.TextEmpty(1);
				out.Write(mem,add);

					in.Text(add,&mem);
				add=in.TextChar(&wort[0]);
				out.Write(mem,add);

					in.Text(add,&mem);
				add=in.TextEmpty(1);
				out.Write(mem,add);

				if(wort[0]!='=')
					{
					wort[0]=0;
					break;
					}

					in.Text(add,&mem);
				add=in.TextWordEx(wort,sizeof(wort));
				out.Write(mem,add);
				}
			
			continue;
			}

		if(!stricmp(wort,"IMG"  ) ||		// Bild oder Frame
		   !stricmp(wort,"FRAME") )
			{
			for(add=0;mem[add];add++)
				{
				if(mem[add]=='>')break;
				if(!strnicmp(mem+add,"src" ,3) && strwchar(mem[add-1],0xE0) && !strwchar(mem[add+3],0x0F))break;
				}

			out.Write(mem,add);
			if(strnicmp(mem+add,"src",3))continue;
			out.Write(mem+add,3);

				in.Text(add+3,&mem);
			add=in.TextEmpty(1);
			out.Write(mem,add);
				in.Text(add,&mem);

			if(*mem!='='){add=0;continue;}
			out.Write(mem,1);
				in.Text(1,&mem);
			add=in.TextEmpty(1);
				in.Text(add,&mem);

			if(mem[0]=='\'')
				{
				add=in.TextString(wort,sizeof(wort),'\'','\'');
				}
			else{
				add=in.TextString(wort,sizeof(wort));
				}
			
			if(add)
				{
				InsertLink(wort,0,Kette);
				WritePath(BasePath,wort,FilePath,&out);
				continue;
				}

			add=in.TextEmpty(1);
				in.Text(add,&mem);

			add=strcspn(mem," \t\n\r>");
			if(add)
				{
				Kette->Add(add,mem);
				strlcpy(wort,mem,add+1);
				WritePath(BasePath,wort,FilePath,&out);
				}
			
			continue;
			}

		if(!stricmp(wort,"META"))			// Automatische Weiterleitung
			{
			add=in.TextEmpty(1);
			out.Write(mem,add);
				in.Text(add,&mem);

			if(strnicmp(mem,"http-equiv",10)){add=0;continue;}

			out.Write(mem,10);
				in.Text(10,&mem);
			add=in.TextChar(&zeichen);
			out.Write(mem,add);
				in.Text(add,&mem);
			add=in.TextString(wort,sizeof(wort));
			out.Write(mem,add);
				in.Text(add,&mem);

			if(zeichen!='=' || stricmp(wort,"refresh")){add=0;continue;}

			add=in.TextWord(wort,sizeof(wort));
			out.Write(mem,add);
				in.Text(add,&mem);

			if(zeichen!='=' || stricmp(wort,"content")){add=0;continue;}

			add=in.TextChar(&zeichen);
			out.Write(mem,add);
				in.Text(add,&mem);

			if(zeichen!='='){add=0;continue;}

			add=in.TextString(wort,sizeof(wort));
				in.Text(add,&mem);

			for(add=0;wort[add];add++)
				{
				if(strnicmp (wort+add,"URL",3))continue;
				add+=strcspn(wort+add,"=");
				if(wort[add]!='=')continue;
				add++;
				add+=strspn (wort+add," \t\n\r");
				len =strcspn(wort+add,"\"\n\r>");
				wort[add+len]=0;
				Kette->Add(wort+add);
				out.Write("\"0; URL=");
				WritePath(BasePath,wort+add,FilePath,&out,0);
				out.Write("\"");
				break;
				}

			add=0;
			continue;
			}

		add=1;
		out.Write(mem,add);
		}


	out.Close();
	in .Close();


return Kette->Count();
}

//*****************************************************************************
//*
//*		ConvertPathEx
//*
//*****************************************************************************
//	Konvertiert einen Pfad (:*? spezial Zeichen), bei ? wird der Typ ans
//	Ende gesetzt
//	Mode	:	Bit 0 nur konvertieren	wenn wiki Bit gesetzt ist
//				Bit 1  &amp konvertiern
//				Bit 2 Sonderzeichen konvertiern
//				Bit 3 UTF8 konvertiern
void CHttpScan::ConvertPathEx(CString &Path,int Mode)
{

	if(!wiki && (Mode&1))return;
	ConvertPathEx(Path.GetBuffer(Path.GetLength()+16));
	Path.ReleaseBuffer();

}

//*****************************************************************************
//*
//*		ConvertPathEx
//*
//*****************************************************************************
//	Konvertiert einen Pfad (:*? spezial Zeichen), bei ? wird der Typ ans
//	Ende gesetzt
//	Mode	:	Bit 0 nur konvertieren	wenn wiki Bit gesetzt ist
//				Bit 1  &amp konvertiern
//				Bit 2 Sonderzeichen konvertiern
//				Bit 3 UTF8 konvertiern
void CHttpScan::ConvertPathEx(char *Path,int Mode)
{
char		suffix[16];
unsigned 	sign;
int			len;
int			pos;
int			max;
int			val;
int			num;


	if(!wiki && (Mode&1))return;
	if(Path[0] && Path[1]==':')Path+=2;

	if(Mode&2)
	for(pos=0;Path[pos];pos++)
		{
		if(Path[pos]=='%' && Path[pos+1] && Path[pos+2])
			{
			suffix[0] = Path[pos+1];
			suffix[1] = Path[pos+2];
			suffix[2] = 0;

			val=strtoi(suffix,16,&num);

			if(val && num==2)
				{
				if(val==':' )val='.';
				if(val=='/' )val='.';
				if(val=='\\')val='.';

				len=strlen(Path+pos+2);
				memmove(Path+pos+1,Path+pos+3,len);
				Path[pos]=val;
				pos--;
				continue;
				}
			}

		if(Path[pos]=='&' && Path[pos+1]=='a' && Path[pos+2]=='m' && Path[pos+3]=='p' && Path[pos+4]==';')
			{
			len=strlen(Path+pos+4);
			memmove(Path+pos+1,Path+pos+5,len);
			Path[pos]='&';
			pos--;
			continue;
			}

		if(Path[pos]=='&' && Path[pos+1]=='l' && Path[pos+2]=='t' && Path[pos+3]==';')
			{
			len=strlen(Path+pos+3);
			memmove(Path+pos+1,Path+pos+4,len);
			Path[pos]='<';
			pos--;
			continue;
			}

		if(Path[pos]=='&' && Path[pos+1]=='g' && Path[pos+2]=='t' && Path[pos+3]==';')
			{
			len=strlen(Path+pos+3);
			memmove(Path+pos+1,Path+pos+4,len);
			Path[pos]='>';
			pos--;
			continue;
			}
		}
			  
	for(pos=0;Path[pos];pos++)
		{
		if(Mode&8)
		if((Path[pos]&0xC0)==0xC0)	
			{
			num=utf8tochar(Path+pos,sign);

			if(num>1)
				{
				len=strlen(Path+pos+num-1);
				memmove(Path+pos+1,Path+pos+num,len);
				Path[pos]=sign;
				pos--;
				continue;
				}
			}

		
		if(!(Mode&4))continue;

		if(Path[pos]==':')Path[pos]='.';
		if(Path[pos]=='=')Path[pos]='.';
		if(Path[pos]=='#')Path[pos]='.';
		if(Path[pos]=='&')Path[pos]='.';
		if(Path[pos]=='*')Path[pos]='_';
		if(Path[pos]=='?')
			{
			len = strdwlen(Path+pos,0x00000200,pos);
		
			if(len<10 && len<pos && Path[pos-len-1]=='.')
				{
				max = strlen(Path+pos);
				num = 0; //strbwlen(Path+pos+max,0x06,max);
				len++;

				if(num==0 || num>5 || num>max-1 || Path[pos+max-num-1]!='.')
					{
					if(len==4 && !memicmp(Path+pos-len,".php",4))
						{
						memcpy(suffix,".htm",len);
						}
					else{
						memcpy(suffix,Path+pos-len,len);
						}

					memmove(Path+pos-len,Path+pos,max);
					memcpy (Path+pos-len+max,suffix,len);
					Path[pos+max]=0;
					Path[pos-len] = '.';
					pos -= len;
					}
				else{
					if(len==4 && !memicmp(Path+pos-len,".php",4))
						{
						memmove(Path+pos-len,Path+pos,max-3);
						pos -= len;
						}

					Path[pos]='.';
					}
				}
			}
		}

}

//*****************************************************************************
//*
//*		MultiScan
//*
//*****************************************************************************
//	Scanned ab HttpPath alle Links und speichert sie im Pfad FilePath
//	ber einen Index kann Reihe von Dateien angegeben die durchsucht werden
//	HttpPath	: Kann eine HTML-Datei auf der Festplatte sein
//				  Ein Web-Pfad   "www.abc_server.com"
//							     "http://www.abc_server.com"
//							     "http://www.abc_server.com/files"
//								 "http://www.abc_server.com/files/"
//				  Eine Web-Datei "www.abc_server.com/main.htm"
//							     "http://www.abc_server.com/main.html"
//				  mit %i,%x,%02i ... kann man den Ort der Reihe angeben
//	FilePath	: Ist der Ziel-Pfad auf der Festplatte
//	Ebene		: Ist die Maximale Anzahl an Link Ebene die durchlaufen werden
//	Flags		: CHS_LOKAL		0x0001	Nur lokale Pfade
//				  CHS_LOKALNEXT	0x0002	Nur lokale Pfade ab der 2. Ebenen
//				  CHS_SUBFILTER	0x0004	Nur Pfade die zum Subfilterpassen weiterverfolgen
//				  CHS_DEBUG		0x0008	Einzel Abfrage starten
//				  CHS_SERVER	0x0010	Nur am gleichen Server suchen
//	Start		: Anfangs Index
//	End			: End Index
//	Step		: Schrittweite fr Index
//	Ergibt die Anzahl der gescannten Dateien bzw. -1 bei einem Benutzter Abbruch
int CHttpScan::MultiScan(LPCTSTR HttpPath,LPCTSTR FilePath,int Ebene,int Flags,int Start,int End,int Step)
{
char			*file;
int				 nr;
CString			 path,http;
CStringChain	 files;
BOOL			 is_web,is_file,is_type;
FILE			*temp;



	http   = HttpPath;						// Pfad Testen
	is_web = CheckWebPath(http);
			 PathCompress(http);
			 PathConvert (http,'/');

	if(is_web)								// BackSlash anhngen
		{
		is_file = IsFile(http);
		is_type = CmpFileType(http,"");
		if(is_file && is_type)
			{
			AddBackSlash(http);
			PathConvert (http,'/');
			is_file=0;
			}
		}


//******************** Temporre Datei erzeugen *******************************

	if(is_web)
		{
		if(!is_file)return 0;

		path =FilePath;
		path+=(LPCSTR)http+FilePathLen(http,1);
		}
	else{
		file=GetFileName(http);
		is_file=(*file!=0);
		if(!is_file)return 0;

		path =FilePath;
		path+=(LPCSTR)http+FilePathLen(http,2);
		}

	SetFileName(path,"");
	CreatePath (GetPath(path));
	SetFileName(path,"HttpScan.tmp.html");

		temp=fopen(GetPath(path),"wb");
	if(!temp)return 0;

	fprintf(temp,"<HTML><BODY>\n");

	for(nr=Start;nr<End;nr+=Step)
		{
		fprintf(temp,"<a href=\"");
		fprintf(temp,http,nr);
		fprintf(temp,"\">"	);
		fprintf(temp,http,nr);
		fprintf(temp,"</a><br>\n");
		}

	fprintf(temp,"</HTML></BODY>\n");
	fclose(temp);

	SetFileName(http,"HttpScan.tmp.html");

	return Scan(http,FilePath,Ebene+1,Flags|CHS_TEMPREAD,0);
}

//*****************************************************************************
//*
//*		Scan
//*
//*****************************************************************************
//	Scanned ab HttpPath alle Links und speichert sie im Pfad FilePath
//	HttpPath	: Kann eine HTML-Datei auf der Festplatte sein
//				  Ein Web-Pfad   "www.abc_server.com"
//							     "http://www.abc_server.com"
//							     "http://www.abc_server.com/files"
//								 "http://www.abc_server.com/files/"
//				  Eine Web-Datei "www.abc_server.com/main.htm"
//							     "http://www.abc_server.com/main.html"
//	FilePath	: Ist der Ziel-Pfad auf der Festplatte
//	Ebene		: Ist die Maximale Anzahl an Link Ebene die durchlaufen werden
//	Flags		: CHS_LOKAL		    0x0001	Nur lokale Pfade
//				  CHS_LOKALNEXT	    0x0002	Nur lokale Pfade ab der 2. Ebenen
//				  CHS_SUBFILTER	    0x0004	Nur Pfade die zum Subfilterpassen weiterverfolgen
//				  CHS_DEBUG		    0x0008	Einzel Abfrage starten
//				  CHS_SERVER	    0x0010	Nur am gleichen Server suchen
//				  CHS_NEWREAD	    0x0020	HTML Dateien immer neu downloaden
//				  CHS_NEWREAD_EX    0x0040	Andere Dateien immer neu downloaden
//				  CHS_NEXTTURN	    0x8000	Ist nicht der 1. Aufruf
//				  CHS_NEWLOCAL	    0x4000	Neuer lokaler Zweig
//				  CHS_TEMPREAD	    0x2000	Erste HTML Datei nie downloaden
//				  CHS_WIKIDOWNLOAD	0x1000  Auch unterelemente wie "index.php?xxxx" herunterladen	
//				  CHS_SCANFILETYPE	0x0800	Prft ob eine Datei vom Typ HTML ist, ohne Suffix
//	NewScan		: Wird ein neue Scan begonnen
//	Ergibt die Anzahl der gescannten Dateien bzw. -1 bei einem Benutzter Abbruch
int CHttpScan::Scan(LPCTSTR HttpPath,LPCTSTR FilePath,int Ebene,int Flags,int NewScan)
{
const char		*file,*ptr;
char			 name[1024];
char			 mem [1024];
int				 anz=0,first=0;
int				 server_len;
int				 x,y,nr,len;
BOOL			 force_html;
BOOL			 is_lokal=0;
BOOL			 is_web=0;
BOOL			 is_file;
BOOL			 is_type;
CStringChain	 files;
CString			 path;
CString			 temp;
CString			 http;
CString			 base;
CString			 save;
unsigned		 diff;
unsigned		 time;



	if(NewScan)done_files.Del();

	scantype= Flags&CHS_SCANFILETYPE;
	wiki	= Flags&CHS_WIKIDOWNLOAD;
	http	= HttpPath;						// Pfad Testen
	is_web	= CheckWebPath(http);
			  PathCompress(http);
			  PathConvert (http,'/');

	strlcpy(name,http,sizeof(name));
	x = strchar(name,'?');


	if(name[x] && wiki)
		{
		name[x]=0;
		}


	if(is_web)								// BackSlash anhngen
		{
		is_file = IsFile(http);
		is_type = CmpFileType(name,"");

		
		if(scantype)
			{
			ptr = GetFileName(http);
			
			if(!stricmp(ptr,"makefile"))	// makefiles bei githup nicht in eigenens Verzeichniss
				{
				is_type = 0;
				}

			if(!stricmp(ptr,"sources"))		// sources bei githup nicht in eigenens Verzeichniss
				{
				is_type = 0;
				}

			if(!stricmp(ptr,"dirs"))		// dirs bei githup nicht in eigenens Verzeichniss
				{
				is_type = 0;
				}
			}
		
		if(!is_file || is_type)
			{
			AddBackSlash(http);
			PathConvert (http,'/');
			is_file=0;
			}
		}

	if(~Flags&CHS_NEXTTURN)					// Erster Aufruf
		{
		tick		= 0;
		stop		= 0;
		first		= 1;
		path_name[0]= 0;
		error_text	= "";
		dont_scan.Del();
		}

	   x=dont_scan.FindFast(http,0,-1,1);	// Schon gescannt oder gesperrt
	if(x!=-1)
		{
		if(dont_scan.DataGet(x)>=Ebene)return 0;
		}

	if(Flags&CHS_DEBUG)						// Abfragen ob scannen
	if(CmpFileType(name,WEB_TYPES))			// Nur Html Dateien Scannen
		{
		path  = "Soll die Datei:\n";
		path += HttpPath;
		path += "\ngesannt werden ?";
		   x =MessageBox(0,path,"HttpScann",MB_YESNOCANCEL|MB_ICONQUESTION);
		if(x==IDNO){x=1000;dont_scan.Add(HttpPath,CSC_END,&x);return 0;}
		if(x==IDCANCEL){Break();return -1;}
		}

	if(Ebene<0)return 0;					// Prfe Ebene
  
	force_html = 0;


//******************** Web-Datei herunter laden *******************************


	if(is_web)								// "http://..."
		{
		if(!is_file)
			{
			path =FilePath;
			path+=(LPCSTR)http+FilePathLen(http,1);

			AddBackSlash(path);

			x=FilePathLen(path,2);
			y=FilePathLen(path);

			path+=IndexNames[0];
			nr=(y>x)? -1:0;					// Gibt es einen unter Pfad

			ConvertPathEx(path);

											// Schon gescannt oder gesperrt
			if(dont_scan.FindFast(path,0,-1,1)!=-1)
				{
				return 0;
				}

			for(;;nr++)						// Suche Index Datei
				{
				if(nr>=0 && !IndexNames[nr])break;
				if(stop)					// Benutzer Abbruch
					{
					if(first && scantype)FixLinks(HttpPath,FilePath,Flags);
					return -1;
					}

				if(nr>=0)SetFileName(http,IndexNames[nr]);

				save=GetPath (path);
				if(ExistFile (save)==1)		// Datei schon vorhanden ?
				if(LengthFile(save)> 0)is_lokal=1;

				if(~Flags&CHS_TEMPREAD)		// Nie neu runder laden
					{
					if(Flags&CHS_NEWREAD)	// Immer neu runder laden (html)
					if(CmpFileType(path,WEB_TYPES))
						{
						is_lokal=0;
						}

					if( Flags&CHS_NEWREAD_EX)// Immer neu runder laden (andere)
					if(!CmpFileType(path,WEB_TYPES))
						{
						is_lokal=0;
						}
					}

				if(is_lokal)break;

				int err=GetFile(http,path,(IndexNames[nr+1])? 1:0,&force_html);
				if(!err)break;
				if( err==12007)Break();		// Benutzer Abbruch
				}

			if(!IndexNames[nr])				// WebFile nicht gefunden
				{
				SetFileName(http,IndexNames[0]);
				if(proc)proc(param,http,CHS_ERR_NOTFOUND);
				return 0;
				}
			}
		else{								// Pfad mit Dateiangabe
			path = FilePath;
			path+=(LPCSTR)http+FilePathLen(http,1);

			ConvertPathEx(path);

											// Schon gescannt oder gesperrt
			if(dont_scan.FindFast(path,0,-1,1)!=-1)return 0;

			file=GetFileName(path);
			for(nr=1;IndexNames[nr];nr++)	// Tausche "welcome.html" to "index.html"
				{
				if(stricmp (file,IndexNames[nr]))continue;
				SetFileName(path,IndexNames[0]);
				break;
				}

			if(CmpFileType(path,"htm;php"))	// "*.htm" zu "*.html"
				{
				SetFileType(path,"html");
				}

			save=GetPath (path);

			if(ExistLink(path,&temp))		// Existiert eine Link-Datei ("...link.html")
				{
				save = temp;
				force_html = 3;
				}
			
			if(ExistFile (save)==1)			// Datei schon vorhanden ?
			if(LengthFile(save)>0)is_lokal=1;

			if(~Flags&CHS_TEMPREAD)			// Nie neu runder laden
				{
				if( Flags&CHS_NEWREAD)		// Immer neu runder laden (html)
				if(CmpFileType(name,WEB_TYPES))
					{
					is_lokal=0;
					}

				if(Flags&CHS_NEWREAD_EX)	// Immer neu runder laden (andere)
				if(!CmpFileType(name,WEB_TYPES))
					{
					is_lokal=0;
					}
				}

			if(!is_lokal)
			if(GetFile(http,path,0,&force_html))
				{
				if(proc)proc(param,http,CHS_ERR_NOTFOUND);
				return 0;
				}
			}
		}

//******************** Normale Datei laden ************************************


	if(!is_web)
		{
		save = GetPath(http);

		if(ExistFile(save)>=2)				// Zeigt Pfad auf ein Verzeichnis
			{
			AddBackSlash(http);
			}

		file=GetFileName(http);
		is_file=(*file!=0);

		if(!is_file)						// Keine Dateiangabe
			{
			path =FilePath;
			path+=(LPCSTR)http+FilePathLen(http,2);
			path+=IndexNames[0];
			PathConvert(path,'/');
			GetFilePath(temp,path);
			CreatePath (GetPath(temp));

			for(nr=0;IndexNames[nr];nr++)	// Suche Index Datei
				{
				if(stop)					// Benutzer Abbruch
					{
					if(first && scantype)FixLinks(HttpPath,FilePath,Flags);
					return -1;
					}

				SetFileName(http,IndexNames[nr]);

				save =GetPath(path);
				if(ExistFile (save)==1)
				if(LengthFile(save)> 0)
					{
					is_lokal=1;break;
					}

				if(CopyFile(GetPath(http),save,0))break;
				}

			if(!IndexNames[nr])				// Datei nicht gefunden
				{
				SetFileName(http,IndexNames[0]);
				if(proc)proc(param,http,CHS_ERR_NOTFOUND);
				return 0;
				}
			}
		else{
			path  = FilePath;
			path += (LPCSTR)http+FilePathLen(http,1);
			PathConvert(path,'/');
			GetFilePath(temp,path);
			CreatePath (GetPath(temp));

			save=GetPath(path);
			if(ExistFile(save)==1)is_lokal=1;
			else if(!CopyFile(GetPath(http),save,0))
				{
				if(proc)proc(param,http,CHS_ERR_NOTFOUND);
				return 0;
				}
			}
		}


	if(force_html && LengthFile(path)>0)	// Nicht-HTML-Typ in HTML umbenenen
		{
		temp  = path;
		temp += ".link.html";

		if(MoveFile(path,temp))
			{
			force_html = 2;
			path = temp;
			}
		else{
			RemoveFile(temp);

			if(MoveFile(path,temp))
				{
				force_html = 2;
				path = temp;				
				}
			}
		}


//******************** Prfen ob die gescannt werden soll *********************


	if(proc)								// Callback fr's einfgen einer Datei	
		{
		if(force_html>=2)
			{
			temp  = http;
			x	  = strchar(temp,'?');
			
			if(x<base.GetLength())
				{
				temp = temp.Left(x);
				}
	
			temp += ".link.html";
			proc(param,temp,(is_lokal)? CHS_OK_LOKAL:CHS_OK);
			}
		else{
			proc(param,http,(is_lokal)? CHS_OK_LOKAL:CHS_OK);
			}
		}
	
											// Nur Html Dateien Scannen
	if(!force_html && !CmpFileType(path,WEB_TYPES))		
		{
		if(first && scantype)FixLinks(HttpPath,FilePath,Flags);
		return 1;
		}


	dont_scan.Add(http,CSC_ABCG,&Ebene);	// Nur einmal Scannen
	dont_scan.Add(path,CSC_ABCG,&Ebene);


//******************** Dateien in HTML Datei scannen **************************


	temp  = path;							// Temporr Datei
	temp +=".tmp";
	base  = http;
	x	  = strchar(base,'?');
	
	if(x<base.GetLength())
		{
		base = base.Left(x);
		}


	SubFileName (base);
	AddBackSlash(base);
	PathConvert (base,'/');

	if(!(Flags&CHS_NEXTTURN)  ||			// Neuer lokaler Zweig
		(Flags&CHS_NEWLOCAL))
		{
		path_base=base;
		Flags&=~CHS_NEWLOCAL;
		}

										   // Wurde die Datei bereits gescannt
	if(done_files.FindFast(path,0,-1,0x01)<0)	
		{	
		done_files.Add(path,CSC_ABCG);

		if(force_html==2)
			{
			done_files.Add(path.GetLength()-9,path,CSC_ABCG);
			}

		ScanFile(path,&files,temp,base);

		save=GetPath(temp);

		if(ExistFile(save)==1)				// Temporr File benutzen
			{
			if(LengthFile(save)>0)
				{
				RemoveFile(path);
				MoveFile  (save,path);
				}
			else{
				RemoveFile(save);
				}
			}
		}
	
	
	if(Ebene<=0)return 0;


	time = GetTickCount();
	diff = time-last_path;

	if(diff>15000)							// Leere Anzeige verhintern
		{
		last_path = time-14000;
		sprintf(path_name,"#SCAN: %s",GetFileName(path));
		}


	server_len = FilePathLen(path_base,2);

	for(x=0;x<files.Count();x++)			// Sub Dateien Holen
		{
		if(stop)break;						// Benutzer Abbruch

		path=files[x];

		is_lokal=1;
		is_web=CheckWebPath(path);

		if(!is_web)							// Voller Dateiname
			{
			PathFullMake(temp,base,path,2);
			path=temp;
			}

		PathCompress(path);					// Entferne . und ..
		PathConvert (path,'/');
		len	  =	path.GetLength();
		file  = path;

		while(len>0)						// Suche Dateinamen	
			{
			if(file[len-1]=='/')break;
			if(file[len-1]==':' && len>1 && file[len-2]=='/')break;
			len--;
			} 

		file += len;

		if(~Flags&CHS_TEMPREAD)
		if( Flags&CHS_LOKAL)				// Nur Lokale Links
			{
			if(strnicmp(path,path_base,path_base.GetLength()))
				{
				if(proc)proc(param,path,CHS_ERR_LOCAL);
				continue;
				}
			}

		if(~Flags&CHS_TEMPREAD)
		if( Flags&CHS_SERVER)				// Nur Server Links
			{
			if(strnicmp(path,path_base,server_len))
				{
				if(proc)proc(param,path,CHS_ERR_SERVER);
				continue;
				}
			}

		if(~Flags&CHS_TEMPREAD)
		if( Flags&CHS_SUBFILTER && sfilter_on)// Nur bestimmte SubPfade
			{
			UINT	fillen=sfilter.GetLength();
			LPCTSTR	filter=sfilter;
			int 	cmp,len,not,add;
				
			if(sfilter_mode)
				{
				not = 0;
				add = 0;

				for(;*filter;filter+=len)
					{
					if(*filter==';')
						{
						filter++;
						len=0;
						continue;
						}

					len = strchar(filter,';');


					if(*filter=='!')
						{
							cmp=!memxcmp(filter+1,len-1,path,path.GetLength(),0x01);
						if(!cmp){not++;break;}
						}
					else{
							cmp= memxcmp(filter,len,path,path.GetLength(),0x01);
						if(!cmp)add++;
						}
					}

				if(not || !add)
					{
					if(proc)proc(param,path,CHS_ERR_SUBFILTER);
					continue;
					}
				}
			else{
				if(strnicmp(path,filter,fillen))
					{
					if(proc)proc(param,path,CHS_ERR_SUBFILTER);
					continue;
					}
				}
			}

		
		
		if(scantype)						// Speziller githup Filter f(fr 40 Byte HEX)
			{
			ptr = path;
			
			for(y=0;ptr[y];y++)					
				{
				if(ptr[y]!='/' && ptr[y]!='\\')continue;
				if(strwlen(ptr+y+1,0x00040007)==40)break;
				}

			if(ptr[y])continue;
			}

		ptr = file;
		y   = strchar(ptr,'?');

		if(ptr[y])							// alles nach "...?xxxx" ignorieren
			{
			strlcpy(mem,ptr,sizeof(mem),y);
			ptr = mem;
			}

		if(CmpFileType(ptr,""))				// Kein Dateisuffix
			{
			ptr = "index.html";
			}


		if(*ptr && pfilter.Count())			// Plus Filter
			{
			for(y=0;y<pfilter.Count();y++)
				{
				if(!memxcmp(pfilter[y],ptr,strlen(ptr),1))break;
				}

			if(y>=pfilter.Count())
				{
				if(proc)proc(param,path,CHS_ERR_PLUS);
				continue;
				}
			}

		if(*ptr && mfilter.Count())			// Minus Filter
			{
			for(y=0;y<mfilter.Count();y++)
				{
				if(!memxcmp(mfilter[y],ptr,strlen(ptr),1))break;
				}

			if(y<mfilter.Count())
				{
				if(proc)proc(param,path,CHS_ERR_MINUS);
				continue;
				}
			}

		if(Flags&CHS_LOKAL)Flags&=~CHS_LOKALNEXT;

		if(Flags&CHS_TEMPREAD)
			{
			anz+=Scan(path,FilePath,Ebene-1,Flags&~CHS_TEMPREAD,0);
			}
		else if(Flags&CHS_LOKALNEXT)
			{
			Flags|=CHS_LOKAL;
			temp=path_base;
			anz+=Scan(path,FilePath,Ebene-1,Flags|CHS_NEXTTURN|CHS_LOKAL|CHS_NEWLOCAL,0);
			path_base=temp;
			}
		else{
			anz+=Scan(path,FilePath,Ebene-1,Flags|CHS_NEXTTURN,0);
			}
		}


	if(first && scantype)FixLinks(HttpPath,FilePath,Flags);


return anz;
}


//*****************************************************************************
//*
//*		FixLinks
//*
//*****************************************************************************
//	Repariert Links in heruntergeladenen Dateien (index.hlml oder .link.html)
//	HttpPath	: Kann eine HTML-Datei auf der Festplatte sein
//				  Ein Web-Pfad   "www.abc_server.com"
//							     "http://www.abc_server.com"
//							     "http://www.abc_server.com/files"
//								 "http://www.abc_server.com/files/"
//				  Eine Web-Datei "www.abc_server.com/main.htm"
//							     "http://www.abc_server.com/main.html"
//	FilePath	: Ist der Ziel-Pfad auf der Festplatte
//	Flags		: CHS_LOKAL		    0x0001	Nur lokale Pfade
//				  CHS_LOKALNEXT	    0x0002	Nur lokale Pfade ab der 2. Ebenen
//				  CHS_SUBFILTER	    0x0004	Nur Pfade die zum Subfilterpassen weiterverfolgen
//				  CHS_DEBUG		    0x0008	Einzel Abfrage starten
//				  CHS_SERVER	    0x0010	Nur am gleichen Server suchen
//				  CHS_NEWREAD	    0x0020	HTML Dateien immer neu downloaden
//				  CHS_NEWREAD_EX    0x0040	Andere Dateien immer neu downloaden
//				  CHS_NEXTTURN	    0x8000	Ist nicht der 1. Aufruf
//				  CHS_NEWLOCAL	    0x4000	Neuer lokaler Zweig
//				  CHS_TEMPREAD	    0x2000	Erste HTML Datei nie downloaden
//				  CHS_WIKIDOWNLOAD	0x1000  Auch unterelemente wie "index.php?xxxx" herunterladen	
//				  CHS_SCANFILETYPE	0x0800	Prft ob eine Datei vom Typ HTML ist, ohne Suffix
//	Ergibt die Anzahl der gescannten Dateien bzw. -1 bei einem Benutzter Abbruch
int CHttpScan::FixLinks(LPCTSTR HttpPath,LPCTSTR FilePath,int Flags)
{
CStringChain	chain;
CFileFinder		find;
const char	   *name; 
const char	   *past;
char			http[256];
char			path[256];
char			temp[256];
int				off;
int				len;
int				num;


	off = 0;							
	if(!strnicmp(HttpPath,"http://" ,7))off=7;
	if(!strnicmp(HttpPath,"https://",8))off=8;

	strlcpy(http,HttpPath,sizeof(http));
	
	if(!CmpFileType(http,""))
		{
		SubFileName(http);
		}

	


	len = strlcpy(path,FilePath,sizeof(path));
	len = AddBackSlash(path,len);

	if(Flags&CHS_LOKALNEXT)
		{
		len += strlcpy(path+len,http+off,sizeof(path)-len);
		}
	else{
		num  = strcwlen(http+off,0x00300000)+off;
		len += strlcpy(path+len,http+off,sizeof(path)-len,num);
		http[num] = 0;
		}

	num = AddBackSlash('/',http);
	find.Set(path,CFF_FIND_SUBDIR,"*.html");

	for(;;)
		{
			name = find.Next(1);
		if(!name)break;

		
		past = find.NamePost();
		       strlcpy(http+num,past  ,sizeof(http)-num);
			   SubFileName(http+num);
			   AddBackSlash(http);

		len  = strlcpy(temp,name      ,sizeof(temp)    );
		       strlcpy(temp+len,".tmp",sizeof(temp)-len);
		
		ScanFile(name,&chain,temp,http);

		if(ExistFile(temp)==1)				// Temporr File benutzen
			{
			if(LengthFile(temp)>0)
				{
				RemoveFile(name);
				MoveFile  (temp,name);
				}
			else{
				RemoveFile(temp);
				}
			}

		chain.Del();
		}


return 0;
}