//*****************************************************************************
//*
//*		
//*		CScanHttp
//*		
//*
//*****************************************************************************
#if !defined(AFX_HTTPSCAN_H__AAAAEAC4_C33A_11D5_A6FA_00E07D8693A5__INCLUDED_)
#define      AFX_HTTPSCAN_H__AAAAEAC4_C33A_11D5_A6FA_00E07D8693A5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif

#include	"StringChain.h"


#define 	CHS_LOKAL			0x0001		// Nur lokale Pfade
#define 	CHS_LOKALNEXT		0x0002		// Nur lokale Pfade ab der 2. Ebenen
#define 	CHS_SUBFILTER		0x0004		// Nur Pfade die zum Subfilterpassen weiterverfolgen
#define 	CHS_DEBUG			0x0008		// Einzel Abfrage starten
#define 	CHS_SERVER			0x0010		// Nur am gleichen Server suchen
#define 	CHS_NEWREAD			0x0020		// HTML Dateien immer neu downloaden
#define 	CHS_NEWREAD_EX		0x0040		// Andere Dateien immer neu downloaden
#define 	CHS_NEXTTURN		0x8000		// Ist nicht der 1. Aufruf
#define 	CHS_NEWLOCAL		0x4000		// Neuer lokaler Zweig
#define 	CHS_TEMPREAD		0x2000		// Erste HTML Dateie immer nie downloaden
#define 	CHS_WIKIDOWNLOAD	0x1000		// Auch unterelemente wie "index.php?xxxx" herunterladen
#define 	CHS_SCANFILETYPE	0x0800		// Prft ob eine Datei vom Typ HTML ist, ohne Suffix

// Typen fr Log Procetur

#define 	CHS_OK				0
#define 	CHS_OK_LOKAL		7
#define 	CHS_ERR_NOTFOUND	1
#define 	CHS_ERR_PLUS		2
#define 	CHS_ERR_MINUS		3
#define 	CHS_ERR_LOCAL		4
#define 	CHS_ERR_SERVER		5
#define 	CHS_ERR_SUBFILTER	6

class	CFileBuffer;

//*****************************************************************************
//*
//*		Klasse CHttpScan
//*
//*****************************************************************************
class	CHttpScan
{
public:

	 CHttpScan();
	~CHttpScan();
	
	int		MultiScan(LPCTSTR HttpPath,LPCTSTR FilePath,int Ebene,int Flags=0,int Start=1,int End=10,int Step=1);
	int		Scan(LPCTSTR HttpPath,LPCTSTR FilePath,int Ebene=2,int Flags=0,int NewScan=1);
	int		SetMinusFilter(LPCTSTR Filter);
	int		SetPlusFilter (LPCTSTR Filter);
	int		SetSubFilter  (LPCTSTR Filter);	
	int		SetLogProc	  (void (__cdecl *proc)(void *,const char *,int),void *Param);	
	void	SetAccessType (int iType);
	LPCSTR	GetErrorText();
	LPCSTR	GetErrorFile();
	LPCSTR	GetPathName();
	UINT	GetFileLength();
	UINT	GetTick();	
	void	Break();
	void	ConvertPathEx(CString    &Path,int Mode=15);
	void	ConvertPathEx(char       *Path,int Mode=15);
	
	CStringChain	cookies;

protected:

	LPCSTR	GetPath(LPCSTR	Path);
	int		GetFile (LPCTSTR HttpPath,LPCTSTR FilePath,int Test=0,int *ForceHtml=0);	
	int		ScanFile(LPCTSTR FilePath,CStringChain *Kette,LPCTSTR OutPath=0,LPCTSTR BasePath=0);
	int 	CheckWebPath  (CString    &Path);
	int 	IsWebPath     (const char *Path);
	int 	IsInWikiFilter(const char *Link,int Len=-1);
	LPCTSTR	InsertLink    (const char *Link,char *Orig,CStringChain *Kette);
	int		ExistLink     (const char *Path,CString *Temp);
	int		FixLinks      (LPCTSTR HttpPath,LPCTSTR FilePath,int Flags);

	int 	IsFile      (const char *Path);
	int		WritePath	(const char *BasePath,const char *Path,const char *FileBase,CFileBuffer *File,int Suffix=1);

	void   (__cdecl *proc)(void *,const char *,int);
	void   *param;
	DWORD	dwAccessType;
	DWORD	dwFileLength;
	
	volatile BOOL	stop;
	unsigned 		tick;
	unsigned		last_path;
	BOOL			wiki;
	BOOL			scantype;
	BOOL			newread_on;
	BOOL			sfilter_on;
	UINT			sfilter_mode;
	char 			path_name[1024];
	CString			path_base;
	CString			error_text;
	CString			error_file;
	CStringChain	done_files;
	CStringChain	dont_scan;
	CStringChain	pfilter;
	CStringChain	mfilter;
	CStringChain	wfilter;
	CString			sfilter;
	CString			xpath;

};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline	void	CHttpScan::Break(){stop=1;}
inline	UINT	CHttpScan::GetTick(){return tick;}
inline	UINT	CHttpScan::GetFileLength(){return dwFileLength;}
inline	LPCSTR	CHttpScan::GetPathName (){return path_name ;}
inline	LPCSTR	CHttpScan::GetErrorText(){return error_text;}
inline	LPCSTR	CHttpScan::GetErrorFile(){return error_file;}
#endif 	