//*****************************************************************************
//*
//*
//*		HttpScanDlg.cpp : Implementierungsdatei
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include	"StdAfx.h"
#include	"StartProg.h"
#include	"HttpScanApp.h"
#include	"HttpScanDlg.h"
#include	"HttpScan.h"
#include	"AfxUtility.h"
#include	"CokkieDlg.h"
#include	"InfoDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 ID_VIEW_SOURCE		0x3033
#define 	 ID_VIEW_FILE		0x3034
#define 	 ID_COPY_PATH		0x3035



BEGIN_MESSAGE_MAP(CHttpScanDlg, CDialog)
	//{{AFX_MSG_MAP(CHttpScanDlg)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(NM_DBLCLK, IDC_TREE,	OnDblclkTree)
	ON_NOTIFY(NM_RCLICK, IDC_TREE,	OnRclickTree)
	ON_BN_CLICKED(IDC_COOKIE,		OnCookie)
	ON_BN_CLICKED(IDC_CHECK3,		OnCheck)
	ON_BN_CLICKED(IDC_MULTI,		OnMulti)
	ON_BN_CLICKED(IDC_INFO,			OnInfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CHttpScanDlg::CHttpScanDlg(CWnd *pParent) : CDialog(CHttpScanDlg::IDD,pParent)
{
void   *mem;
CString name;
CString text;
CString path;
char	param[32];
int		pos;

	//{{AFX_DATA_INIT(CHttpScanDlg)
	basepath		= _T("");
	targetpath		= _T("");
	filefilter		= _T("*.jpg;*.jpeg;*.gif;*.png");
	mfilter			= _T("");
	subfilterstr	= _T("");
	depth			= 10;
	lokal			= TRUE;
	server			= TRUE;
	tree_on			= TRUE;
	down_loaderr	= TRUE;
	sublokal		= FALSE;
	subfilter		= FALSE;
	debug_on		= FALSE;
	expand			= FALSE;
	new_read		= FALSE;
	new_read_xx		= FALSE;
	wiki_download	= FALSE;
	scan_none_htm	= FALSE;
	//}}AFX_DATA_INIT

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	thread_run=0;
	tree_item=0;
	multiscan=0;


	CRegKeys	key;

	chain_base  .Add("www.linux.com");
	chain_target.Add("C:\\User\\HttpScan");
	chain_target.Add("C:\\Temp\\HttpScan");
	chain_filter.Add("*.jpg;*.jpeg");
	chain_filter.Add("*.jpg;*.jpeg;*.gif;*.png");
	chain_minus .Add("tn_*.j*;*IC.j*");

	key.Open();
	key.Get(basepath	 ,"BasePath");
	key.Get(targetpath	 ,"TargetPath");
	key.Get(filefilter	 ,"FileFilter");
	key.Get(mfilter		 ,"MinusFilter");
	key.Get(depth		 ,"Depth");
	key.Get(lokal		 ,"Lokal");
	key.Get(server		 ,"Server");
	key.Get(sublokal	 ,"SubLokal");
	key.Get(subfilter	 ,"SubFilter");
	key.Get(subfilterstr ,"SubFilterText");
	key.Get(debug_on	 ,"Debug");
	key.Get(tree_on		 ,"TreeOn");
	key.Get(down_loaderr ,"DownloadError");
	key.Get(expand		 ,"AutoExpand");
	key.Get(new_read	 ,"NewRead");
	key.Get(new_read_xx	 ,"NewReadEx");
	key.Get(wiki_download,"WikiDownload");
	key.Get(scan_none_htm,"ScanNoneHtml");


	key.Get(&mem		 ,"BaseList");		 if(mem){ chain_base  .Add((char**)&mem); delete mem;}
	key.Get(&mem		 ,"TargetList");	 if(mem){ chain_target.Add((char**)&mem); delete mem;}
	key.Get(&mem		 ,"FileFilterList"); if(mem){ chain_filter.Add((char**)&mem); delete mem;}
	key.Get(&mem		 ,"MinusFilterList");if(mem){ chain_minus .Add((char**)&mem); delete mem;}

	key.Up("Cookies");

	for(pos=0;pos<99;pos++)							// Cookies laden
		{
		name = "";
		text = "";
		path = "";

		sprintf(param,"Path%02i",pos);
		key.Get(path,param);

		sprintf(param,"Name%02i",pos);
		key.Get(name,param);

		sprintf(param,"Text%02i",pos);
		key.Get(text,param);

		if(path.IsEmpty() || name.IsEmpty())
			{
			if(path.IsEmpty() && name.IsEmpty())break;
			continue;
			}
		
		if(pos==0)scan.cookies.Del();

		scan.cookies.Add(path);
		scan.cookies.Add(name);
		scan.cookies.Add(text);
		}

	chain_base  .ContainerInit();
	chain_target.ContainerInit();
	chain_filter.ContainerInit();
	chain_minus .ContainerInit();

	FILE *file;
	char  buffer[256];
	int	  len;


	   file=fopen("WWW_List.txt","r");
	if(file)
		{
		while(fgets(buffer,sizeof(buffer),file))
			{
			len=strcspn(buffer," \t\n\r");
			if(!len)continue;
			www_list.Add(len,buffer);
			}
		fclose(file);
		}

}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CHttpScanDlg::DoDataExchange(CDataExchange *pDX)
{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CHttpScanDlg)
	DDX_CBString(pDX, IDC_COMBO1, basepath);
	DDX_CBString(pDX, IDC_COMBO2, targetpath);
	DDX_CBString(pDX, IDC_COMBO3, filefilter);
	DDX_CBString(pDX, IDC_COMBO4, mfilter);
	DDX_Text (pDX, IDC_EDIT1,   subfilterstr);
	DDX_Text (pDX, IDC_EDIT2,   depth);
	DDX_Check(pDX, IDC_CHECK1,  lokal);
	DDX_Check(pDX, IDC_CHECK2,  sublokal);
	DDX_Check(pDX, IDC_CHECK3,  subfilter);
	DDX_Check(pDX, IDC_CHECK4,  debug_on);
	DDX_Check(pDX, IDC_CHECK5,  server);
	DDX_Check(pDX, IDC_CHECK6,  tree_on);
	DDX_Check(pDX, IDC_CHECK7,  down_loaderr);
	DDX_Check(pDX, IDC_CHECK8,  new_read);
	DDX_Check(pDX, IDC_CHECK9,  expand);
	DDX_Check(pDX, IDC_CHECK10, wiki_download);
	DDX_Check(pDX, IDC_CHECK11, new_read_xx);
	DDX_Check(pDX, IDC_CHECK12, scan_none_htm);
	//}}AFX_DATA_MAP

}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CHttpScanDlg::OnInitDialog()
{
int			x;
HBITMAP		hb;
CRect		rect;



	CDialog::OnInitDialog();


	GetCharWidths(font_size);
	GetDlgItem(IDC_PATH)->GetClientRect(&rect);
	wnd_size=rect.Width();

														// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	SubclassComboBox(this,IDC_COMBO1,SCB_DROPFILE);
	SubclassComboBox(this,IDC_COMBO2,SCB_DROPFILE);

														// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT((IDM_ABOUTBOX < 0xF000));

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	
	if(pSysMenu != NULL)
		{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
			{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
			}
		}

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	CComboBox    *cb;
	CStringChain *sk;
	tree = (CTreeCtrl*)GetDlgItem(IDC_TREE);
	cb   = (CComboBox*)GetDlgItem(IDC_COMBO1);
	sk   = &chain_base;



	hb=(HBITMAP)LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_ICONS),IMAGE_BITMAP,0,0,LR_LOADTRANSPARENT);
	images.Create(16,16,ILC_COLOR8,32,5);
	images.Add(CBitmap::FromHandle(hb),RGB(128,255,255));
	images.SetBkColor(GetSysColor(COLOR_WINDOW));

	tree->SetImageList(&images,TVSIL_NORMAL);
	tree->SetImageList(&images,TVSIL_STATE);

	for(x=0;x<sk->Count();x++)
		{
		cb->AddString(sk->Get(x));
		}

	sk=&www_list;

	for(x=0;x<sk->Count();x++)
		{
		cb->AddString(sk->Get(x));
		}

	cb=(CComboBox*)GetDlgItem(IDC_COMBO2);
	sk=&chain_target;

	for(x=0;x<sk->Count();x++)
		{
		cb->AddString(sk->Get(x));
		}

	cb=(CComboBox*)GetDlgItem(IDC_COMBO3);
	sk=&chain_filter;

	for(x=0;x<sk->Count();x++)
		{
		cb->AddString(sk->Get(x));
		}

	cb=(CComboBox*)GetDlgItem(IDC_COMBO4);
	sk=&chain_minus;

	for(x=0;x<sk->Count();x++)
		{
		cb->AddString(sk->Get(x));
		}

	OnCheck();


return TRUE;
}


//*****************************************************************************
//*
//*		OnSysCommand
//*
//*****************************************************************************
void CHttpScanDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CDialog dlgAbout(IDD_ABOUTBOX,this);
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.
void CHttpScanDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


//*****************************************************************************
//*
//*		OnQueryDragIcon
//*
//*****************************************************************************
HCURSOR CHttpScanDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CHttpScanDlg::OnOK()
{
void   *mem;
int     len,x;


	UpdateData();

	CRegKeys	key;

	key.Open();
	key.Set(basepath	 ,"BasePath");
	key.Set(targetpath	 ,"TargetPath");
	key.Set(filefilter	 ,"FileFilter");
	key.Set(mfilter		 ,"MinusFilter");
	key.Set(depth		 ,"Depth");
	key.Set(lokal		 ,"Lokal");
	key.Set(server		 ,"Server");
	key.Set(sublokal	 ,"SubLokal");
	key.Set(subfilter	 ,"SubFilter");
	key.Set(subfilterstr ,"SubFilterText");
	key.Set(debug_on	 ,"Debug");
	key.Set(tree_on		 ,"TreeOn");
	key.Set(down_loaderr ,"DownloadError");
	key.Set(expand		 ,"AutoExpand");
	key.Set(new_read	 ,"NewRead");
	key.Set(new_read_xx	 ,"NewReadEx");
	key.Set(wiki_download,"WikiDownload");
	key.Set(scan_none_htm,"ScanNoneHtml");
	

	chain_base  .CAdd(basepath   );
	chain_target.CAdd(targetpath );
	chain_filter.CAdd(filefilter );
	chain_minus .CAdd(mfilter    );


	len=chain_base  .Chain((char**)&mem);if(mem){key.Set(mem,len,"BaseList");		delete mem;}
	len=chain_target.Chain((char**)&mem);if(mem){key.Set(mem,len,"TargetList");		delete mem;}
	len=chain_filter.Chain((char**)&mem);if(mem){key.Set(mem,len,"FileFilterList");	delete mem;}
	len=chain_minus .Chain((char**)&mem);if(mem){key.Set(mem,len,"MinusFilterList");delete mem;}

	CComboBox    *cb;
	CStringChain *sk;

	cb=(CComboBox*)GetDlgItem(IDC_COMBO1);
	cb->ResetContent();
	sk=&chain_base;

	for(x=0;x<sk->Count();x++)
		{
		cb->AddString(sk->Get(x));
		}

	sk=&www_list;

	for(x=0;x<sk->Count();x++)
		{
		cb->AddString(sk->Get(x));
		}

	cb=(CComboBox*)GetDlgItem(IDC_COMBO2);
	cb->ResetContent();
	sk=&chain_target;

	for(x=0;x<sk->Count();x++)
		{
		cb->AddString(sk->Get(x));
		}

	cb=(CComboBox*)GetDlgItem(IDC_COMBO3);
	cb->ResetContent();
	sk=&chain_filter;

	for(x=0;x<sk->Count();x++)
		{
		cb->AddString(sk->Get(x));
		}


	cb=(CComboBox*)GetDlgItem(IDC_COMBO4);
	cb->ResetContent();
	sk=&chain_minus;

	for(x=0;x<sk->Count();x++)
		{
		cb->AddString(sk->Get(x));
		}


	UpdateData(FALSE);
	thread_run=1;
	EnableDlgItem(IDOK,0);
	EnableDlgItem(IDC_MULTI,0);
	AfxBeginThread(ThreadProc,this);

}


//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CHttpScanDlg::OnCancel()
{

	if(thread_run)
		{
		scan.Break();
		return;
		}

	CDialog::OnCancel();
}


//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CHttpScanDlg::OnTimer(UINT_PTR nIDEvent)
{
char	path[MAX_PATH];
LPCTSTR file;
int		len;
int		pos;
	
	
	file = scan.GetPathName();

	if(file[0]=='#')
		{
		SetDlgItemText(IDC_TEXT,"");

		CProgressCtrl  *progress;
		progress=(CProgressCtrl*)GetDlgItem(IDC_PROGRESS1);
		pos = progress->GetPos();
		progress->SetPos((pos+1)%100);

		SetDlgItemText(IDC_PATH,file);
		}
	else{
		len = CommpressFileName(file,path,sizeof(path),wnd_size,font_size);

		while(len>0)
			{
			len--;
			if(path[len]=='/' )break;
			if(path[len]=='\\')break;
			if(path[len]==':' && len>0)
				{
				if(path[len-1]=='/' )break;
				if(path[len-1]=='\\')break;
				}
			}
		
		scan.ConvertPathEx(path+len,0x0A);
		SetDlgItemText(IDC_PATH,path);

		CProgressCtrl  *progress;
		progress=(CProgressCtrl*)GetDlgItem(IDC_PROGRESS1);
		progress->SetPos(scan.GetTick()%100);

		sprintf(path," %i kB",scan.GetFileLength()>>10);
		SetDlgItemText(IDC_TEXT,path);
		}


	SetDlgItemText(IDC_ERROR , scan.GetErrorText());
	CommpressFileName(scan.GetErrorFile(),path,sizeof(path),wnd_size,font_size);
	SetDlgItemText(IDC_ERROR1, path);


}

//*****************************************************************************
//*
//*		ThreadProc
//*
//*****************************************************************************
UINT CHttpScanDlg::ThreadProc(LPVOID Param){return ((CHttpScanDlg*)Param)->ThreadProc();}
UINT CHttpScanDlg::ThreadProc()
{
DWORD			flags=0;
CProgressCtrl  *progress;
BOOL			multi;


	base_path = targetpath;
	AddBackSlash(base_path);

	progress=(CProgressCtrl*)GetDlgItem(IDC_PROGRESS1);
	progress->SetRange(0,100);
	SetTimer(0,600,0);
	file_count=0;
	tree_item=0;

	SetDlgItemText(IDC_PATH , "");
	SetDlgItemText(IDC_ERROR, "");

	if(lokal	    )flags |= CHS_LOKAL;
	if(sublokal	    )flags |= CHS_LOKALNEXT;
	if(subfilter    )flags |= CHS_SUBFILTER;
	if(server	    )flags |= CHS_SERVER;
	if(debug_on     )flags |= CHS_DEBUG;
	if(new_read     )flags |= CHS_NEWREAD;
	if(new_read_xx  )flags |= CHS_NEWREAD_EX;
	if(wiki_download)flags |= CHS_WIKIDOWNLOAD;
	if(scan_none_htm)flags |= CHS_SCANFILETYPE;

	tree->DeleteAllItems();
	multi=multiscan;
		  multiscan=0;

	AddBackSlash(targetpath);
	scan.SetPlusFilter(filefilter);
	scan.SetMinusFilter(mfilter);
	scan.SetSubFilter(subfilterstr);
	scan.SetLogProc(Log,this);

	if(multi)scan.MultiScan(basepath,targetpath,depth,flags,mdlg.iStart,mdlg.iEnd,mdlg.iStep);
	else	 scan.Scan     (basepath,targetpath,depth,flags);

	EnableDlgItem(IDOK,1);
	EnableDlgItem(IDC_MULTI,1);
	thread_run=0;

	tree->RedrawWindow();
	progress->SetPos(0);
	KillTimer(0);

return 0;
}


//*****************************************************************************
//*
//*		Log
//*
//*****************************************************************************
//	Aufruf wenn eine Datei herunter geladen wurde.
//	Param	: Zeiger auf Dialog
//	File	: Name der Datei
//	Mode	: Fehlercode
void CHttpScanDlg::Log(void  *Param,const char *File,int Mode)
{
((CHttpScanDlg*)Param)->Log(File,Mode);
}
void CHttpScanDlg::Log(const char *File,int Mode)
{
char		str[1024],temp[1024],*file,alt,typ,num;
int			len,image,ebene=0;
HTREEITEM	root,next;
TVITEM		item;
BOOL		flag;



	if(!tree_on)return;
	if(file_count>4000)return;
	if(down_loaderr)							// Nur Download Fehler anzeigen
		{
		if(Mode!=CHS_OK)
		if(Mode!=CHS_OK_LOKAL)
		if(Mode!=CHS_ERR_NOTFOUND)return;
		}


	typ = -1;
	len = strlen(File);
	num = strbwlen(File+len,0x06,len);

	if(num>=3 && num<len-1 && File[len-num-1]=='.')
		{
		file = (char*)File+len-num-2;
		
		if(CmpFileType(file,"jpg;jpeg;gif;bmp;png" ))
			{
			typ=1;
			}
		}

	if(typ<0)
		{
		strlcpy(temp,File,sizeof(temp),len);
		len = strchar(temp,'?');
		temp[len] = 0;

		file=GetFileName(temp);
		}


	if(!*file)typ=3;
	else if(CmpFileType(file,"htm;html;php;php3;asp"))typ=0;
	else if(CmpFileType(file,"jpg;jpeg;gif;bmp;png" ))typ=1;
	else typ=2;

	if(!strnicmp(File,"http://" ,7))File+=7;
	if(!strnicmp(File,"https://",8))File+=8;
	strlcpy(temp,File,sizeof(temp));
	file=temp;




	len = strcspn(file,"\\/");
	alt = file[len];
	      file[len]=0;
	if(alt && !file[len+1])alt=0;

	if(!alt)return;

	item.pszText=str;
	item.cchTextMax=sizeof(str);
	item.mask=TVIF_PARAM|TVIF_TEXT;

	root = TVI_ROOT;
	next = tree->GetRootItem();
	flag = FALSE;

	for(;;)
		{

		if(next)
			{
			item.hItem=next;
			tree->GetItem(&item);				// Hole Name und Wert

			if(stricmp(file,str))
				{
				next=tree->GetNextItem(next,TVGN_NEXT);
				continue;
				}

			root=next;
			next=tree->GetNextItem(next,TVGN_CHILD);
			}
		else{
			image=(alt)? 3:typ+4*Mode;
			next=tree->InsertItem(	TVIF_TEXT|TVIF_PARAM|TVIF_IMAGE|TVIF_SELECTEDIMAGE,
									file,image,image,0,0,Mode,root,TVI_SORT);
  			if(expand && file_count<100)tree->Expand(root,TVE_EXPAND);

			if(flag)
				{
				flag = TRUE;
				tree->Expand(root,TVE_EXPAND);
				}

			if(root==TVI_ROOT)
				{
				flag = TRUE;
				}

			root = next;
			next = 0;
			}


		if(!alt)break;

		file += len+1;
		file += strspn (file,"\\/");
		len   = strcspn(file,"\\/");
		alt   = file[len];
			    file[len]=0;
		if(alt && !file[len+1])alt=0;
		ebene++;

		if(!alt)
			{
			scan.ConvertPathEx(file,0x0A);
			}
		}



	file_count++;

}


//*****************************************************************************
//*
//*		GetSelPath
//*
//*****************************************************************************
//	Speichert den Pfad des aktuellen Elementes im Treeview in Path
//	Ergibt	0 : Pfad wurde nicht gefunden
//			1 : Pfad wurde gefunden existiert aber nicht
//			2 : Pfad wurde gefunden und existiert
int	CHttpScanDlg::GetSelPath(CString &Path)
{
char			name[16][128];
int				ebene;
CString			temp;
HTREEITEM		next;
TVITEM			item;
int				pos;



	Path="";

	if(base_path==""){tree_item=0;return 0;}

	if(tree_item)
		 next=tree_item;
	else next=tree->GetSelectedItem();

	tree_item=0;

	if(!next)return 0;

	item.cchTextMax=sizeof(name[0]);
	item.mask=TVIF_PARAM|TVIF_TEXT;
	ebene=0;

	while(next && ebene<16)
		{
		item.pszText=name[ebene];
		item.pszText[0]=0;
		item.hItem=next;
		tree->GetItem(&item);				// Hole Name und Wert
		next=tree->GetNextItem(next,TVGN_PARENT);
		ebene++;
		}

	if(ebene<=0)return 0;

	Path = base_path;

	pos = strchar(name[0],'?');
	
	if(name[0][pos])
		{
		temp = name[0];
		ConvertPath(temp);
		strlcpy(name[0],temp,sizeof(name[0]));
		}

	for(ebene--;ebene>=0;ebene--)
		{
		AddBackSlash(Path);
		Path+=name[ebene];
		}

	if(CmpFileType(Path,"htm;shtml"))
	if(ExistFile(Path)!=1)
		{
		temp=Path;
		SetFileType (temp,"html");
		if(ExistFile(temp)==1)Path=temp;
		}

	if(ExistFile(Path)==1)return 2;


return 1;
}

//*****************************************************************************
//*
//*		ViewSourceCode
//*
//*****************************************************************************
int CHttpScanDlg::ViewFile(LPCSTR Path)
{
int nr;


	nr=(int)ShellExecute(this->m_hWnd,"open",Path,0,0,SW_SHOWDEFAULT);


return (nr>=0 && nr<=32)? 0:1;
}

//*****************************************************************************
//*
//*		ViewSourceCode
//*
//*****************************************************************************
int CHttpScanDlg::ViewSourceCode(LPCSTR Path)
{
CString	exe;



	if(!CmpFileType(Path,"htm;html;shtml;php"))
		{
		MessageBeep(MB_OK);
		return 0;
		}

	GetExePath  (exe);
	SetFileName (exe,"Editor.exe");
	if(ExistFile(exe)!=1)SetFileName(exe,"AZ Editor.exe");
	if(ExistFile(exe)!=1)SetFileName(exe,"notepad.exe");
	if(ExistFile(exe)!=1)exe="C:\\Windows\\Editor.exe";
	if(ExistFile(exe)!=1)exe="C:\\Windows\\AZ Editor.exe";
	if(ExistFile(exe)!=1)exe="C:\\Windows\\notepad.exe";
	if(ExistFile(exe)!=1)exe="C:\\WinNt\\Editor.exe";
	if(ExistFile(exe)!=1)exe="C:\\WinNt\\AZ Editor.exe";
	if(ExistFile(exe)!=1)exe="C:\\WinNt\\notepad.exe";
	if(ExistFile(exe)!=1)
		{
		char	dir[MAX_PATH];
		
		GetWindowsDirectory(dir,MAX_PATH);
		exe  = dir;
		exe += "\\notepad.exe";

		if(ExistFile(exe)!=1)
			{
			return 0;
			}
		}

	CStartProg	start;

	start.SetParam(Path);
	start.Start(exe);

return 1;
}

//*****************************************************************************
//*
//*		ConvertPath
//*
//*****************************************************************************
void CHttpScanDlg::ConvertPath(CString &Path)
{
LPCTSTR		name;		
int			len;

	len  = Path.GetLength();
	name = Path.GetBuffer(len+16);

	while(len>0)
		{
		len--;
		if(name[len]=='/' )break;
		if(name[len]=='\\')break;
		if(name[len]==':' && len>0)
			{
			if(name[len-1]=='/' )break;
			if(name[len-1]=='\\')break;
			}
		}

	name += len;
	len = strchar(name,'?');

	if(name[len])
		{			
		scan.ConvertPathEx((char*)name,0x04);
		}

	Path.ReleaseBuffer();

}

//*****************************************************************************
//*
//*		OnDblclkTree
//*
//*****************************************************************************
void CHttpScanDlg::OnDblclkTree(NMHDR *pNmHdr, LRESULT *pResult)
{
CString		path;
CPoint		pos,pview;


	*pResult = 0;

	GetCursorPos(&pos);
	pview  = GetWindowPt(tree);
	tree_item=tree->HitTest(pos-pview,0);

	if(GetSelPath(path)!=2)
		{
		MessageBeep(MB_OK);
		return;
		}

	ConvertPath(path);
	ViewSourceCode(path);
}

//*****************************************************************************
//*
//*		OnRclickTree
//*
//*****************************************************************************
// Startet ein Men bei Pos
// Ist Menu=0 wird ein neues Men erzeugt.
void CHttpScanDlg::OnRclickTree(NMHDR *pNmHdr, LRESULT *pResult)
{
CMenu	menu;
CPoint	pos,pview;


	GetCursorPos(&pos);
	pview  = GetWindowPt(tree);
	tree_item=tree->HitTest(pos-pview,0);

	menu.CreatePopupMenu();
	menu.AppendMenu(MF_STRING,ID_VIEW_SOURCE	, "&Text  anzeigen");
	menu.AppendMenu(MF_STRING,ID_VIEW_FILE		, "&Datei anzeigen");
	menu.AppendMenu(MF_STRING,ID_COPY_PATH		, "&Pfad kopieren");
	menu.TrackPopupMenu(TPM_LEFTALIGN,pos.x,pos.y,this);
	menu.DestroyMenu();



}


//*****************************************************************************
//*
//*		OnCommand
//*
//*****************************************************************************
BOOL CHttpScanDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{

	if(wParam==ID_VIEW_SOURCE)
		{
		CString		path;
		
		if(GetSelPath(path)==2)
			{
			ViewSourceCode(path);
			}

		return TRUE;
		}

	if(wParam==ID_VIEW_FILE)
		{
		CString		path;
		
 		if(GetSelPath(path)==2)
			{
			ViewFile(path);
			}

		return TRUE;
		}

	if(wParam==ID_COPY_PATH)
		{
		CString		path;
		
 		GetSelPath(path);
		if(!path.IsEmpty())SetClipboardText(path);

		return TRUE;
		}


	return CDialog::OnCommand(wParam, lParam);
}


//*****************************************************************************
//*
//*		OnInfo
//*
//*****************************************************************************
void CHttpScanDlg::OnInfo()
{
CInfoDlg	dlg(this);

	dlg.DoModal();
}

//*****************************************************************************
//*
//*		OnCheck
//*
//*****************************************************************************
void CHttpScanDlg::OnCheck()
{

	UpdateData();
	GetDlgItem(IDC_EDIT1)->EnableWindow(subfilter);

}

//*****************************************************************************
//*
//*		OnMulti
//*
//*****************************************************************************
void CHttpScanDlg::OnMulti()
{

	if(mdlg.DoModal()!=IDOK)return;

	multiscan=1;
	OnOK();
}

//*****************************************************************************
//*
//*		OnCookie
//*
//*****************************************************************************
void CHttpScanDlg::OnCookie()
{
CCookieDlg		dlg;
CString			name;
CString			text;
CString 		path;
char			param[32];
int				pos;


	dlg.m_sCookies = scan.cookies;

	if(dlg.DoModal()!=IDOK)return;
	if(dlg.m_sCookies.Count()==0)return;

	scan.cookies = dlg.m_sCookies;

	CRegKeys	key;

	key.Up("Cookies");

	for(pos=0;pos<99;pos++)							// Cookies laden
		{
		if(pos>=scan.cookies.Count()/3)
			{
			break;
			}

		path = scan.cookies[pos*3+0];
		name = scan.cookies[pos*3+1];
		text = scan.cookies[pos*3+2];

		sprintf(param,"Path%02i",pos);
		key.Set(path,param);

		sprintf(param,"Name%02i",pos);
		key.Set(name,param);

		sprintf(param,"Text%02i",pos);
		key.Set(text,param);
		}
	
	for(;pos<99;pos++)								// Cookies laden
		{
		sprintf(param,"Path%02i",pos);
		key.Del(param);

		sprintf(param,"Name%02i",pos);
		key.Del(param);

		sprintf(param,"Text%02i",pos);
		key.Del(param);
		}

}
